/*
 -- ============================================================================
 -- FILE NAME	: bus_addr_dec.v
 -- DESCRIPTION : AhXfR[_
 -- ----------------------------------------------------------------------------
 -- Revision  Date		  Coding_by	 Comment
 -- 1.0.0	  2011/06/27  suito		 VK쐬
 -- ============================================================================
*/

/********** ʃwb_t@C **********/
`include "nettype.h"
`include "stddef.h"
`include "global_config.h"

/********** ʃwb_t@C **********/
`include "bus.h"

/********** W[ **********/
module bus_addr_dec (
	/********** AhX **********/
	input  wire [`WordAddrBus] s_addr, // AhX
	/********** `bvZNg **********/
	output reg				   s0_cs_, // oXX[u0
	output reg				   s1_cs_, // oXX[u1
	output reg				   s2_cs_, // oXX[u2
	output reg				   s3_cs_, // oXX[u3
	output reg				   s4_cs_, // oXX[u4
	output reg				   s5_cs_, // oXX[u5
	output reg				   s6_cs_, // oXX[u6
	output reg				   s7_cs_  // oXX[u7
);

	/********** oXX[uCfbNX **********/
	wire [`BusSlaveIndexBus] s_index = s_addr[`BusSlaveIndexLoc];

	/********** oXX[u}`vNT **********/
	always @(*) begin
		/* `bvZNg̏ */
		s0_cs_ = `DISABLE_;
		s1_cs_ = `DISABLE_;
		s2_cs_ = `DISABLE_;
		s3_cs_ = `DISABLE_;
		s4_cs_ = `DISABLE_;
		s5_cs_ = `DISABLE_;
		s6_cs_ = `DISABLE_;
		s7_cs_ = `DISABLE_;
		/* AhXɑΉX[ȗI */
		case (s_index)
			`BUS_SLAVE_0 : begin // oXX[u0
				s0_cs_	= `ENABLE_;
			end
			`BUS_SLAVE_1 : begin // oXX[u1
				s1_cs_	= `ENABLE_;
			end
			`BUS_SLAVE_2 : begin // oXX[u2
				s2_cs_	= `ENABLE_;
			end
			`BUS_SLAVE_3 : begin // oXX[u3
				s3_cs_	= `ENABLE_;
			end
			`BUS_SLAVE_4 : begin // oXX[u4
				s4_cs_	= `ENABLE_;
			end
			`BUS_SLAVE_5 : begin // oXX[u5
				s5_cs_	= `ENABLE_;
			end
			`BUS_SLAVE_6 : begin // oXX[u6
				s6_cs_	= `ENABLE_;
			end
			`BUS_SLAVE_7 : begin // oXX[u7
				s7_cs_	= `ENABLE_;
			end
		endcase
	end

endmodule
