/*
 -- ============================================================================
 -- FILE	 : bus_arbiter.v
 -- SYNOPSIS : oXA[r^
 -- ----------------------------------------------------------------------------
 -- Revision  Date		  Coding_by	 Comment
 -- 1.0.0	  2011/06/27  suito		 VK쐬
 -- ============================================================================
*/

/********** ʃwb_t@C **********/
`include "nettype.h"
`include "stddef.h"
`include "global_config.h"

/********** ʃwb_t@C **********/
`include "bus.h"

/********** W[ **********/
module bus_arbiter (
	/********** NbN & Zbg **********/
	input  wire		   clk,		 // NbN
	input  wire		   reset,	 // 񓯊Zbg
	/********** A[rg[VM **********/
	// oX}X^0
	input  wire		   m0_req_,	 // oXNGXg
	output reg		   m0_grnt_, // oXOg
	// oX}X^1
	input  wire		   m1_req_,	 // oXNGXg
	output reg		   m1_grnt_, // oXOg
	// oX}X^2
	input  wire		   m2_req_,	 // oXNGXg
	output reg		   m2_grnt_, // oXOg
	// oX}X^3
	input  wire		   m3_req_,	 // oXNGXg
	output reg		   m3_grnt_	 // oXOg
);

	/********** M **********/
	reg [`BusOwnerBus] owner;	 // oX̏L
   
	/********** oXOg̐ **********/
	always @(*) begin
		/* oXOg̏ */
		m0_grnt_ = `DISABLE_;
		m1_grnt_ = `DISABLE_;
		m2_grnt_ = `DISABLE_;
		m3_grnt_ = `DISABLE_;
		/* oXOg̐ */
		case (owner)
			`BUS_OWNER_MASTER_0 : begin // oX}X^0
				m0_grnt_ = `ENABLE_;
			end
			`BUS_OWNER_MASTER_1 : begin // oX}X^1
				m1_grnt_ = `ENABLE_;
			end
			`BUS_OWNER_MASTER_2 : begin // oX}X^2
				m2_grnt_ = `ENABLE_;
			end
			`BUS_OWNER_MASTER_3 : begin // oX}X^3
				m3_grnt_ = `ENABLE_;
			end
		endcase
	end
   
	/********** oX̃A[rg[V **********/
	always @(posedge clk or `RESET_EDGE reset) begin
		if (reset == `RESET_ENABLE) begin
			/* 񓯊Zbg */
			owner <= #1 `BUS_OWNER_MASTER_0;
		end else begin
			/* A[rg[V */
			case (owner)
				`BUS_OWNER_MASTER_0 : begin // oXLҁFoX}X^0
					/* ɃoXl}X^ */
					if (m0_req_ == `ENABLE_) begin			// oX}X^0
						owner <= #1 `BUS_OWNER_MASTER_0;
					end else if (m1_req_ == `ENABLE_) begin // oX}X^1
						owner <= #1 `BUS_OWNER_MASTER_1;
					end else if (m2_req_ == `ENABLE_) begin // oX}X^2
						owner <= #1 `BUS_OWNER_MASTER_2;
					end else if (m3_req_ == `ENABLE_) begin // oX}X^3
						owner <= #1 `BUS_OWNER_MASTER_3;
					end
				end
				`BUS_OWNER_MASTER_1 : begin // oXLҁFoX}X^1
					/* ɃoXl}X^ */
					if (m1_req_ == `ENABLE_) begin			// oX}X^1
						owner <= #1 `BUS_OWNER_MASTER_1;
					end else if (m2_req_ == `ENABLE_) begin // oX}X^2
						owner <= #1 `BUS_OWNER_MASTER_2;
					end else if (m3_req_ == `ENABLE_) begin // oX}X^3
						owner <= #1 `BUS_OWNER_MASTER_3;
					end else if (m0_req_ == `ENABLE_) begin // oX}X^0
						owner <= #1 `BUS_OWNER_MASTER_0;
					end
				end
				`BUS_OWNER_MASTER_2 : begin // oXLҁFoX}X^2
					/* ɃoXl}X^ */
					if (m2_req_ == `ENABLE_) begin			// oX}X^2
						owner <= #1 `BUS_OWNER_MASTER_2;
					end else if (m3_req_ == `ENABLE_) begin // oX}X^3
						owner <= #1 `BUS_OWNER_MASTER_3;
					end else if (m0_req_ == `ENABLE_) begin // oX}X^0
						owner <= #1 `BUS_OWNER_MASTER_0;
					end else if (m1_req_ == `ENABLE_) begin // oX}X^1
						owner <= #1 `BUS_OWNER_MASTER_1;
					end
				end
				`BUS_OWNER_MASTER_3 : begin // oXLҁFoX}X^3
					/* ɃoXl}X^ */
					if (m3_req_ == `ENABLE_) begin			// oX}X^3
						owner <= #1 `BUS_OWNER_MASTER_3;
					end else if (m0_req_ == `ENABLE_) begin // oX}X^0
						owner <= #1 `BUS_OWNER_MASTER_0;
					end else if (m1_req_ == `ENABLE_) begin // oX}X^1
						owner <= #1 `BUS_OWNER_MASTER_1;
					end else if (m2_req_ == `ENABLE_) begin // oX}X^2
						owner <= #1 `BUS_OWNER_MASTER_2;
					end
				end
			endcase
		end
	end

endmodule
