/* 
 -- ============================================================================
 -- FILE NAME	: cpu.h
 -- DESCRIPTION : CPUwb_
 -- ----------------------------------------------------------------------------
 -- Revision  Date		  Coding_by	 Comment
 -- 1.0.0	  2011/06/27  suito		 VK쐬
 -- ============================================================================
*/

`ifndef __CPU_HEADER__
	`define __CPU_HEADER__	// CN[hK[h

//------------------------------------------------------------------------------
// Operation
//------------------------------------------------------------------------------
	/********** WX^ **********/
	`define REG_NUM				 32	  // WX^
	`define REG_ADDR_W			 5	  // WX^AhX
	`define RegAddrBus			 4:0  // WX^AhXoX
	/********** 荞ݗvM **********/
	`define CPU_IRQ_CH			 8	  // IRQ
	/********** ALUIyR[h **********/
	// oX
	`define ALU_OP_W			 4	  // ALUIyR[h
	`define AluOpBus			 3:0  // ALUIyR[hoX
	// IyR[h
	`define ALU_OP_NOP			 4'h0 // No Operation
	`define ALU_OP_AND			 4'h1 // AND
	`define ALU_OP_OR			 4'h2 // OR
	`define ALU_OP_XOR			 4'h3 // XOR
	`define ALU_OP_ADDS			 4'h4 // tZ
	`define ALU_OP_ADDU			 4'h5 // ȂZ
	`define ALU_OP_SUBS			 4'h6 // tZ
	`define ALU_OP_SUBU			 4'h7 // ȂZ
	`define ALU_OP_SHRL			 4'h8 // _EVtg
	`define ALU_OP_SHLL			 4'h9 // _Vtg
	/********** IyR[h **********/
	// oX
	`define MEM_OP_W			 2	  // IyR[h
	`define MemOpBus			 1:0  // IyR[hoX
	// IyR[h
	`define MEM_OP_NOP			 2'h0 // No Operation
	`define MEM_OP_LDW			 2'h1 // [hǂݏo
	`define MEM_OP_STW			 2'h2 // [h
	/********** IyR[h **********/
	// oX
	`define CTRL_OP_W			 2	  // IyR[h
	`define CtrlOpBus			 1:0  // IyR[hoX
	// IyR[h
	`define CTRL_OP_NOP			 2'h0 // No Operation
	`define CTRL_OP_WRCR		 2'h1 // 䃌WX^ւ̏
	`define CTRL_OP_EXRT		 2'h2 // O̕A

	/********** s[h **********/
	// oX
	`define CPU_EXE_MODE_W		 1	  // s[h
	`define CpuExeModeBus		 0:0  // s[hoX
	// s[h
	`define CPU_KERNEL_MODE		 1'b0 // J[l[h
	`define CPU_USER_MODE		 1'b1 // [U[h

//------------------------------------------------------------------------------
// 䃌WX^
//------------------------------------------------------------------------------
	/********** AhX}bv **********/
	`define CREG_ADDR_STATUS	 5'h0  // Xe[^X
	`define CREG_ADDR_PRE_STATUS 5'h1  // ÕXe[^X
	`define CREG_ADDR_PC		 5'h2  // vOJE^
	`define CREG_ADDR_EPC		 5'h3  // OvOJE^
	`define CREG_ADDR_EXP_VECTOR 5'h4  // OxN^
	`define CREG_ADDR_CAUSE		 5'h5  // OWX^
	`define CREG_ADDR_INT_MASK	 5'h6  // 荞݃}XN
	`define CREG_ADDR_IRQ		 5'h7  // 荞ݗv
	// ǂݏop̈
	`define CREG_ADDR_ROM_SIZE	 5'h1d // ROMTCY
	`define CREG_ADDR_SPM_SIZE	 5'h1e // SPMTCY
	`define CREG_ADDR_CPU_INFO	 5'h1f // CPU
	/********** rbg}bv **********/
	`define CregExeModeLoc		 0	   // s[ḧʒu
	`define CregIntEnableLoc	 1	   // 荞ݗL̈ʒu
	`define CregExpCodeLoc		 2:0   // OR[ḧʒu
	`define CregDlyFlagLoc		 3	   // fBCXbgtÖʒu

//------------------------------------------------------------------------------
// oXC^tF[X
//------------------------------------------------------------------------------
	/********** oXC^tF[X̏ **********/
	// oX
	`define BusIfStateBus		 1:0   // ԃoX
	// 
	`define BUS_IF_STATE_IDLE	 2'h0  // ACh
	`define BUS_IF_STATE_REQ	 2'h1  // oXNGXg
	`define BUS_IF_STATE_ACCESS	 2'h2  // oXANZX
	`define BUS_IF_STATE_STALL	 2'h3  // Xg[

//------------------------------------------------------------------------------
// MISC
//------------------------------------------------------------------------------
	/********** xN^ **********/
	`define RESET_VECTOR		 30'h0 // ZbgxN^
	/********** Vtg **********/
	`define ShAmountBus			 4:0   // VtgʃoX
	`define ShAmountLoc			 4:0   // Vtgʂ̈ʒu

	/********** CPU *********/
	`define RELEASE_YEAR		 8'd41 // 쐬N (YYYY - 1970)
	`define RELEASE_MONTH		 8'd7  // 쐬
	`define RELEASE_VERSION		 8'd1  // o[W
	`define RELEASE_REVISION	 8'd0  // rW


`endif
