/*
 -- ============================================================================
 -- FILE NAME	: alu.v
 -- DESCRIPTION : Zp_Zjbg
 -- ----------------------------------------------------------------------------
 -- Revision  Date		  Coding_by	 Comment
 -- 1.0.0	  2011/06/27  suito		 VK쐬
 -- ============================================================================
*/

/********** ʃwb_t@C **********/
`include "nettype.h"
`include "global_config.h"
`include "stddef.h"

/********** ʃwb_t@C **********/
`include "cpu.h"

/********** W[ **********/
module alu (
	input  wire [`WordDataBus] in_0,  //  0
	input  wire [`WordDataBus] in_1,  //  1
	input  wire [`AluOpBus]	   op,	  // Iy[V
	output reg	[`WordDataBus] out,	  // o
	output reg				   of	  // I[ot[
);

	/********** to͐M **********/
	wire signed [`WordDataBus] s_in_0 = $signed(in_0); // t 0
	wire signed [`WordDataBus] s_in_1 = $signed(in_1); // t 1
	wire signed [`WordDataBus] s_out  = $signed(out);  // to

	/********** Zp_Z **********/
	always @(*) begin
		case (op)
			`ALU_OP_AND	 : begin // _ρiANDj
				out	  = in_0 & in_1;
			end
			`ALU_OP_OR	 : begin // _aiORj
				out	  = in_0 | in_1;
			end
			`ALU_OP_XOR	 : begin // rI_aiXORj
				out	  = in_0 ^ in_1;
			end
			`ALU_OP_ADDS : begin // tZ
				out	  = in_0 + in_1;
			end
			`ALU_OP_ADDU : begin // ȂZ
				out	  = in_0 + in_1;
			end
			`ALU_OP_SUBS : begin // tZ
				out	  = in_0 - in_1;
			end
			`ALU_OP_SUBU : begin // ȂZ
				out	  = in_0 - in_1;
			end
			`ALU_OP_SHRL : begin // _EVtg
				out	  = in_0 >> in_1[`ShAmountLoc];
			end
			`ALU_OP_SHLL : begin // _Vtg
				out	  = in_0 << in_1[`ShAmountLoc];
			end
			default		 : begin // ftHgl (No Operation)
				out	  = in_0;
			end
		endcase
	end

	/********** I[ot[`FbN **********/
	always @(*) begin
		case (op)
			`ALU_OP_ADDS : begin // ZI[ot[̃`FbN
				if (((s_in_0 > 0) && (s_in_1 > 0) && (s_out < 0)) ||
					((s_in_0 < 0) && (s_in_1 < 0) && (s_out > 0))) begin
					of = `ENABLE;
				end else begin
					of = `DISABLE;
				end
			end
			`ALU_OP_SUBS : begin // ZI[ot[̃`FbN
				if (((s_in_0 < 0) && (s_in_1 > 0) && (s_out > 0)) ||
					((s_in_0 > 0) && (s_in_1 < 0) && (s_out < 0))) begin
					of = `ENABLE;
				end else begin
					of = `DISABLE;
				end
			end
			default		: begin // ftHgl
				of = `DISABLE;
			end
		endcase
	end

endmodule
