/*
 -- ============================================================================
 -- FILE NAME	: bus_if.v
 -- DESCRIPTION : oXC^tF[X
 -- ----------------------------------------------------------------------------
 -- Revision  Date		  Coding_by	 Comment
 -- 1.0.0	  2011/06/27  suito		 VK쐬
 -- ============================================================================
*/

/********** ʃwb_t@C **********/
`include "nettype.h"
`include "global_config.h"
`include "stddef.h"

/********** ʃwb_t@C **********/
`include "cpu.h"
`include "bus.h"

/********** W[ **********/
module bus_if (
	/********** NbN & Zbg **********/
	input  wire				   clk,			   // NbN
	input  wire				   reset,		   // 񓯊Zbg
	/********** pCvCM **********/
	input  wire				   stall,		   // Xg[
	input  wire				   flush,		   // tbVM
	output reg				   busy,		   // rW[M
	/********** CPUC^tF[X **********/
	input  wire [`WordAddrBus] addr,		   // AhX
	input  wire				   as_,			   // AhXL
	input  wire				   rw,			   // ǂ݁^
	input  wire [`WordDataBus] wr_data,		   // ݃f[^
	output reg	[`WordDataBus] rd_data,		   // ǂݏof[^
	/********** SPMC^tF[X **********/
	input  wire [`WordDataBus] spm_rd_data,	   // ǂݏof[^
	output wire [`WordAddrBus] spm_addr,	   // AhX
	output reg				   spm_as_,		   // AhXXg[u
	output wire				   spm_rw,		   // ǂ݁^
	output wire [`WordDataBus] spm_wr_data,	   // ݃f[^
	/********** oXC^tF[X **********/
	input  wire [`WordDataBus] bus_rd_data,	   // ǂݏof[^
	input  wire				   bus_rdy_,	   // fB
	input  wire				   bus_grnt_,	   // oXOg
	output reg				   bus_req_,	   // oXNGXg
	output reg	[`WordAddrBus] bus_addr,	   // AhX
	output reg				   bus_as_,		   // AhXXg[u
	output reg				   bus_rw,		   // ǂ݁^
	output reg	[`WordDataBus] bus_wr_data	   // ݃f[^
);

	/********** M **********/
	reg	 [`BusIfStateBus]	   state;		   // oXC^tF[X̏
	reg	 [`WordDataBus]		   rd_buf;		   // ǂݏoobt@
	wire [`BusSlaveIndexBus]   s_index;		   // oXX[uCfbNX

	/********** oXX[ũCfbNX **********/
	assign s_index	   = addr[`BusSlaveIndexLoc];

	/********** o͂̃ATC **********/
	assign spm_addr	   = addr;
	assign spm_rw	   = rw;
	assign spm_wr_data = wr_data;
						 
	/********** ANZX̐ **********/
	always @(*) begin
		/* ftHgl */
		rd_data	 = `WORD_DATA_W'h0;
		spm_as_	 = `DISABLE_;
		busy	 = `DISABLE;
		/* oXC^tF[X̏ */
		case (state)
			`BUS_IF_STATE_IDLE	 : begin // ACh
				/* ANZX */
				if ((flush == `DISABLE) && (as_ == `ENABLE_)) begin
					/* ANZX̑I */
					if (s_index == `BUS_SLAVE_1) begin // SPMփANZX
						if (stall == `DISABLE) begin // Xg[̃`FbN
							spm_as_	 = `ENABLE_;
							if (rw == `READ) begin // ǂݏoANZX
								rd_data	 = spm_rd_data;
							end
						end
					end else begin					   // oXփANZX
						busy	 = `ENABLE;
					end
				end
			end
			`BUS_IF_STATE_REQ	 : begin // oXNGXg
				busy	 = `ENABLE;
			end
			`BUS_IF_STATE_ACCESS : begin // oXANZX
				/* fB҂ */
				if (bus_rdy_ == `ENABLE_) begin // fB
					if (rw == `READ) begin // ǂݏoANZX
						rd_data	 = bus_rd_data;
					end
				end else begin					// fB
					busy	 = `ENABLE;
				end
			end
			`BUS_IF_STATE_STALL	 : begin // Xg[
				if (rw == `READ) begin // ǂݏoANZX
					rd_data	 = rd_buf;
				end
			end
		endcase
	end

   /********** oXC^tF[X̏Ԑ **********/ 
   always @(posedge clk or `RESET_EDGE reset) begin
		if (reset == `RESET_ENABLE) begin
			/* 񓯊Zbg */
			state		<= #1 `BUS_IF_STATE_IDLE;
			bus_req_	<= #1 `DISABLE_;
			bus_addr	<= #1 `WORD_ADDR_W'h0;
			bus_as_		<= #1 `DISABLE_;
			bus_rw		<= #1 `READ;
			bus_wr_data <= #1 `WORD_DATA_W'h0;
			rd_buf		<= #1 `WORD_DATA_W'h0;
		end else begin
			/* oXC^tF[X̏ */
			case (state)
				`BUS_IF_STATE_IDLE	 : begin // ACh
					/* ANZX */
					if ((flush == `DISABLE) && (as_ == `ENABLE_)) begin 
						/* ANZX̑I */
						if (s_index != `BUS_SLAVE_1) begin // oXփANZX
							state		<= #1 `BUS_IF_STATE_REQ;
							bus_req_	<= #1 `ENABLE_;
							bus_addr	<= #1 addr;
							bus_rw		<= #1 rw;
							bus_wr_data <= #1 wr_data;
						end
					end
				end
				`BUS_IF_STATE_REQ	 : begin // oXNGXg
					/* oXOg҂ */
					if (bus_grnt_ == `ENABLE_) begin // oXl
						state		<= #1 `BUS_IF_STATE_ACCESS;
						bus_as_		<= #1 `ENABLE_;
					end
				end
				`BUS_IF_STATE_ACCESS : begin // oXANZX
					/* AhXXg[ũlQ[g */
					bus_as_		<= #1 `DISABLE_;
					/* fB҂ */
					if (bus_rdy_ == `ENABLE_) begin // fB
						bus_req_	<= #1 `DISABLE_;
						bus_addr	<= #1 `WORD_ADDR_W'h0;
						bus_rw		<= #1 `READ;
						bus_wr_data <= #1 `WORD_DATA_W'h0;
						/* ǂݏof[^̕ۑ */
						if (bus_rw == `READ) begin // ǂݏoANZX
							rd_buf		<= #1 bus_rd_data;
						end
						/* Xg[̃`FbN */
						if (stall == `ENABLE) begin // Xg[
							state		<= #1 `BUS_IF_STATE_STALL;
						end else begin				// Xg[
							state		<= #1 `BUS_IF_STATE_IDLE;
						end
					end
				end
				`BUS_IF_STATE_STALL	 : begin // Xg[
					/* Xg[̃`FbN */
					if (stall == `DISABLE) begin // Xg[
						state		<= #1 `BUS_IF_STATE_IDLE;
					end
				end
			endcase
		end
	end

endmodule
