/*
 -- ============================================================================
 -- FILE NAME	: cpu.v
 -- DESCRIPTION : CPUgbvW[
 -- ----------------------------------------------------------------------------
 -- Revision  Date		  Coding_by	 Comment
 -- 1.0.0	  2011/06/27  suito		 VK쐬
 -- ============================================================================
*/

/********** ʃwb_t@C **********/
`include "nettype.h"
`include "global_config.h"
`include "stddef.h"

/********** ʃwb_t@C **********/
`include "isa.h"
`include "cpu.h"
`include "bus.h"
`include "spm.h"

/********** W[ **********/
module cpu (
	/********** NbN & Zbg **********/
	input  wire					  clk,			   // NbN
	input  wire					  clk_,			   // ]NbN
	input  wire					  reset,		   // 񓯊Zbg
	/********** oXC^tF[X **********/
	// IF Stage
	input  wire [`WordDataBus]	  if_bus_rd_data,  // ǂݏof[^
	input  wire					  if_bus_rdy_,	   // fB
	input  wire					  if_bus_grnt_,	   // oXOg
	output wire					  if_bus_req_,	   // oXNGXg
	output wire [`WordAddrBus]	  if_bus_addr,	   // AhX
	output wire					  if_bus_as_,	   // AhXXg[u
	output wire					  if_bus_rw,	   // ǂ݁^
	output wire [`WordDataBus]	  if_bus_wr_data,  // ݃f[^
	// MEM Stage
	input  wire [`WordDataBus]	  mem_bus_rd_data, // ǂݏof[^
	input  wire					  mem_bus_rdy_,	   // fB
	input  wire					  mem_bus_grnt_,   // oXOg
	output wire					  mem_bus_req_,	   // oXNGXg
	output wire [`WordAddrBus]	  mem_bus_addr,	   // AhX
	output wire					  mem_bus_as_,	   // AhXXg[u
	output wire					  mem_bus_rw,	   // ǂ݁^
	output wire [`WordDataBus]	  mem_bus_wr_data, // ݃f[^
	/********** 荞 **********/
	input  wire [`CPU_IRQ_CH-1:0] cpu_irq		   // 荞ݗv
);

	/********** pCvCWX^ **********/
	// IF/ID
	wire [`WordAddrBus]			 if_pc;			 // vOJE^
	wire [`WordDataBus]			 if_insn;		 // 
	wire						 if_en;			 // pCvCf[^̗L
	// ID/EXpCvCWX^
	wire [`WordAddrBus]			 id_pc;			 // vOJE^
	wire						 id_en;			 // pCvCf[^̗L
	wire [`AluOpBus]			 id_alu_op;		 // ALUIy[V
	wire [`WordDataBus]			 id_alu_in_0;	 // ALU 0
	wire [`WordDataBus]			 id_alu_in_1;	 // ALU 1
	wire						 id_br_flag;	 // tO
	wire [`MemOpBus]			 id_mem_op;		 // Iy[V
	wire [`WordDataBus]			 id_mem_wr_data; // ݃f[^
	wire [`CtrlOpBus]			 id_ctrl_op;	 // Iy[V
	wire [`RegAddrBus]			 id_dst_addr;	 // GPR݃AhX
	wire						 id_gpr_we_;	 // GPRݗL
	wire [`IsaExpBus]			 id_exp_code;	 // OR[h
	// EX/MEMpCvCWX^
	wire [`WordAddrBus]			 ex_pc;			 // vOJE^
	wire						 ex_en;			 // pCvCf[^̗L
	wire						 ex_br_flag;	 // tO
	wire [`MemOpBus]			 ex_mem_op;		 // Iy[V
	wire [`WordDataBus]			 ex_mem_wr_data; // ݃f[^
	wire [`CtrlOpBus]			 ex_ctrl_op;	 // 䃌WX^Iy[V
	wire [`RegAddrBus]			 ex_dst_addr;	 // ėpWX^݃AhX
	wire						 ex_gpr_we_;	 // ėpWX^ݗL
	wire [`IsaExpBus]			 ex_exp_code;	 // OR[h
	wire [`WordDataBus]			 ex_out;		 // 
	// MEM/WBpCvCWX^
	wire [`WordAddrBus]			 mem_pc;		 // vOJE^
	wire						 mem_en;		 // pCvCf[^̗L
	wire						 mem_br_flag;	 // tO
	wire [`CtrlOpBus]			 mem_ctrl_op;	 // 䃌WX^Iy[V
	wire [`RegAddrBus]			 mem_dst_addr;	 // ėpWX^݃AhX
	wire						 mem_gpr_we_;	 // ėpWX^ݗL
	wire [`IsaExpBus]			 mem_exp_code;	 // OR[h
	wire [`WordDataBus]			 mem_out;		 // 
	/********** pCvCM **********/
	// Xg[M
	wire						 if_stall;		 // IFXe[W
	wire						 id_stall;		 // IDXe[
	wire						 ex_stall;		 // EXXe[W
	wire						 mem_stall;		 // MEMXe[W
	// tbVM
	wire						 if_flush;		 // IFXe[W
	wire						 id_flush;		 // IDXe[W
	wire						 ex_flush;		 // EXXe[W
	wire						 mem_flush;		 // MEMXe[W
	// rW[M
	wire						 if_busy;		 // IFXe[W
	wire						 mem_busy;		 // MEMXe[W
	// ̑̐M
	wire [`WordAddrBus]			 new_pc;		 // VPC
	wire [`WordAddrBus]			 br_addr;		 // AhX
	wire						 br_taken;		 // ̐
	wire						 ld_hazard;		 // [hnU[h
	/********** ėpWX^M **********/
	wire [`WordDataBus]			 gpr_rd_data_0;	 // ǂݏof[^ 0
	wire [`WordDataBus]			 gpr_rd_data_1;	 // ǂݏof[^ 1
	wire [`RegAddrBus]			 gpr_rd_addr_0;	 // ǂݏoAhX 0
	wire [`RegAddrBus]			 gpr_rd_addr_1;	 // ǂݏoAhX 1
	/********** 䃌WX^M **********/
	wire [`CpuExeModeBus]		 exe_mode;		 // s[h
	wire [`WordDataBus]			 creg_rd_data;	 // ǂݏof[^
	wire [`RegAddrBus]			 creg_rd_addr;	 // ǂݏoAhX
	/********** Interrupt Request **********/
	wire						 int_detect;	  // 荞݌o
	/********** XNb`pbhM **********/
	// IFXe[W
	wire [`WordDataBus]			 if_spm_rd_data;  // ǂݏof[^
	wire [`WordAddrBus]			 if_spm_addr;	  // AhX
	wire						 if_spm_as_;	  // AhXXg[u
	wire						 if_spm_rw;		  // ǂ݁^
	wire [`WordDataBus]			 if_spm_wr_data;  // ݃f[^
	// MEMXe[W
	wire [`WordDataBus]			 mem_spm_rd_data; // ǂݏof[^
	wire [`WordAddrBus]			 mem_spm_addr;	  // AhX
	wire						 mem_spm_as_;	  // AhXXg[u
	wire						 mem_spm_rw;	  // ǂ݁^
	wire [`WordDataBus]			 mem_spm_wr_data; // ݃f[^
	/********** tH[fBOM **********/
	wire [`WordDataBus]			 ex_fwd_data;	  // EXXe[W
	wire [`WordDataBus]			 mem_fwd_data;	  // MEMXe[W

	/********** IFXe[W **********/
	if_stage if_stage (
		/********** NbN & Zbg **********/
		.clk			(clk),				// NbN
		.reset			(reset),			// 񓯊Zbg
		/********** SPMC^tF[X **********/
		.spm_rd_data	(if_spm_rd_data),	// ǂݏof[^
		.spm_addr		(if_spm_addr),		// AhX
		.spm_as_		(if_spm_as_),		// AhXXg[u
		.spm_rw			(if_spm_rw),		// ǂ݁^
		.spm_wr_data	(if_spm_wr_data),	// ݃f[^
		/********** oXC^tF[X **********/
		.bus_rd_data	(if_bus_rd_data),	// ǂݏof[^
		.bus_rdy_		(if_bus_rdy_),		// fB
		.bus_grnt_		(if_bus_grnt_),		// oXOg
		.bus_req_		(if_bus_req_),		// oXNGXg
		.bus_addr		(if_bus_addr),		// AhX
		.bus_as_		(if_bus_as_),		// AhXXg[u
		.bus_rw			(if_bus_rw),		// ǂ݁^
		.bus_wr_data	(if_bus_wr_data),	// ݃f[^
		/********** pCvCM **********/
		.stall			(if_stall),			// Xg[
		.flush			(if_flush),			// tbV
		.new_pc			(new_pc),			// VPC
		.br_taken		(br_taken),			// ̐
		.br_addr		(br_addr),			// AhX
		.busy			(if_busy),			// rW[M
		/********** IF/IDpCvCWX^ **********/
		.if_pc			(if_pc),			// vOJE^
		.if_insn		(if_insn),			// 
		.if_en			(if_en)				// pCvCf[^̗L
	);

	/********** IDXe[W **********/
	id_stage id_stage (
		/********** NbN & Zbg **********/
		.clk			(clk),				// NbN
		.reset			(reset),			// 񓯊Zbg
		/********** GPRC^tF[X **********/
		.gpr_rd_data_0	(gpr_rd_data_0),	// ǂݏof[^ 0
		.gpr_rd_data_1	(gpr_rd_data_1),	// ǂݏof[^ 1
		.gpr_rd_addr_0	(gpr_rd_addr_0),	// ǂݏoAhX 0
		.gpr_rd_addr_1	(gpr_rd_addr_1),	// ǂݏoAhX 1
		/********** tH[fBO **********/
		// EXXe[W̃tH[fBO
		.ex_en			(ex_en),			// pCvCf[^̗L
		.ex_fwd_data	(ex_fwd_data),		// tH[fBOf[^
		.ex_dst_addr	(ex_dst_addr),		// ݃AhX
		.ex_gpr_we_		(ex_gpr_we_),		// ݗL
		// MEMXe[W̃tH[fBO
		.mem_fwd_data	(mem_fwd_data),		// tH[fBOf[^
		/********** 䃌WX^C^tF[X **********/
		.exe_mode		(exe_mode),			// s[h
		.creg_rd_data	(creg_rd_data),		// ǂݏof[^
		.creg_rd_addr	(creg_rd_addr),		// ǂݏoAhX
		/********** pCvCM **********/
	   .stall		   (id_stall),		   // Xg[
		.flush			(id_flush),			// tbV
		.br_addr		(br_addr),			// AhX
		.br_taken		(br_taken),			// ̐
		.ld_hazard		(ld_hazard),		// [hnU[h
		/********** IF/IDpCvCWX^ **********/
		.if_pc			(if_pc),			// vOJE^
		.if_insn		(if_insn),			// 
		.if_en			(if_en),			// pCvCf[^̗L
		/********** ID/EXpCvCWX^ **********/
		.id_pc			(id_pc),			// vOJE^
		.id_en			(id_en),			// pCvCf[^̗L
		.id_alu_op		(id_alu_op),		// ALUIy[V
		.id_alu_in_0	(id_alu_in_0),		// ALU 0
		.id_alu_in_1	(id_alu_in_1),		// ALU 1
		.id_br_flag		(id_br_flag),		// tO
		.id_mem_op		(id_mem_op),		// Iy[V
		.id_mem_wr_data (id_mem_wr_data),	// ݃f[^
		.id_ctrl_op		(id_ctrl_op),		// Iy[V
		.id_dst_addr	(id_dst_addr),		// GPR݃AhX
		.id_gpr_we_		(id_gpr_we_),		// GPRݗL
		.id_exp_code	(id_exp_code)		// OR[h
	);

	/********** EXXe[W **********/
	ex_stage ex_stage (
		/********** NbN & Zbg **********/
		.clk			(clk),				// NbN
		.reset			(reset),			// 񓯊Zbg
		/********** pCvCM **********/
		.stall			(ex_stall),			// Xg[
		.flush			(ex_flush),			// tbV
		.int_detect		(int_detect),		// 荞݌o
		/********** tH[fBO **********/
		.fwd_data		(ex_fwd_data),		// tH[fBOf[^
		/********** ID/EXpCvCWX^ **********/
		.id_pc			(id_pc),			// vOJE^
		.id_en			(id_en),			// pCvCf[^̗L
		.id_alu_op		(id_alu_op),		// ALUIy[V
		.id_alu_in_0	(id_alu_in_0),		// ALU 0
		.id_alu_in_1	(id_alu_in_1),		// ALU 1
		.id_br_flag		(id_br_flag),		// tO
		.id_mem_op		(id_mem_op),		// Iy[V
		.id_mem_wr_data (id_mem_wr_data),	// ݃f[^
		.id_ctrl_op		(id_ctrl_op),		// 䃌WX^Iy[V
		.id_dst_addr	(id_dst_addr),		// ėpWX^݃AhX
		.id_gpr_we_		(id_gpr_we_),		// ėpWX^ݗL
		.id_exp_code	(id_exp_code),		// OR[h
		/********** EX/MEMpCvCWX^ **********/
		.ex_pc			(ex_pc),			// vOJE^
		.ex_en			(ex_en),			// pCvCf[^̗L
		.ex_br_flag		(ex_br_flag),		// tO
		.ex_mem_op		(ex_mem_op),		// Iy[V
		.ex_mem_wr_data (ex_mem_wr_data),	// ݃f[^
		.ex_ctrl_op		(ex_ctrl_op),		// 䃌WX^Iy[V
		.ex_dst_addr	(ex_dst_addr),		// ėpWX^݃AhX
		.ex_gpr_we_		(ex_gpr_we_),		// ėpWX^ݗL
		.ex_exp_code	(ex_exp_code),		// OR[h
		.ex_out			(ex_out)			// 
	);

	/********** MEMXe[W **********/
	mem_stage mem_stage (
		/********** NbN & Zbg **********/
		.clk			(clk),				// NbN
		.reset			(reset),			// 񓯊Zbg
		/********** pCvCM **********/
		.stall			(mem_stall),		// Xg[
		.flush			(mem_flush),		// tbV
		.busy			(mem_busy),			// rW[M
		/********** tH[fBO **********/
		.fwd_data		(mem_fwd_data),		// tH[fBOf[^
		/********** SPMC^tF[X **********/
		.spm_rd_data	(mem_spm_rd_data),	// ǂݏof[^
		.spm_addr		(mem_spm_addr),		// AhX
		.spm_as_		(mem_spm_as_),		// AhXXg[u
		.spm_rw			(mem_spm_rw),		// ǂ݁^
		.spm_wr_data	(mem_spm_wr_data),	// ݃f[^
		/********** oXC^tF[X **********/
		.bus_rd_data	(mem_bus_rd_data),	// ǂݏof[^
		.bus_rdy_		(mem_bus_rdy_),		// fB
		.bus_grnt_		(mem_bus_grnt_),	// oXOg
		.bus_req_		(mem_bus_req_),		// oXNGXg
		.bus_addr		(mem_bus_addr),		// AhX
		.bus_as_		(mem_bus_as_),		// AhXXg[u
		.bus_rw			(mem_bus_rw),		// ǂ݁^
		.bus_wr_data	(mem_bus_wr_data),	// ݃f[^
		/********** EX/MEMpCvCWX^ **********/
		.ex_pc			(ex_pc),			// vOJE^
		.ex_en			(ex_en),			// pCvCf[^̗L
		.ex_br_flag		(ex_br_flag),		// tO
		.ex_mem_op		(ex_mem_op),		// Iy[V
		.ex_mem_wr_data (ex_mem_wr_data),	// ݃f[^
		.ex_ctrl_op		(ex_ctrl_op),		// 䃌WX^Iy[V
		.ex_dst_addr	(ex_dst_addr),		// ėpWX^݃AhX
		.ex_gpr_we_		(ex_gpr_we_),		// ėpWX^ݗL
		.ex_exp_code	(ex_exp_code),		// OR[h
		.ex_out			(ex_out),			// 
		/********** MEM/WBpCvCWX^ **********/
		.mem_pc			(mem_pc),			// vOJE^
		.mem_en			(mem_en),			// pCvCf[^̗L
		.mem_br_flag	(mem_br_flag),		// tO
		.mem_ctrl_op	(mem_ctrl_op),		// 䃌WX^Iy[V
		.mem_dst_addr	(mem_dst_addr),		// ėpWX^݃AhX
		.mem_gpr_we_	(mem_gpr_we_),		// ėpWX^ݗL
		.mem_exp_code	(mem_exp_code),		// OR[h
		.mem_out		(mem_out)			// 
	);

	/********** 䃆jbg **********/
	ctrl ctrl (
		/********** NbN & Zbg **********/
		.clk			(clk),				// NbN
		.reset			(reset),			// 񓯊Zbg
		/********** 䃌WX^C^tF[X **********/
		.creg_rd_addr	(creg_rd_addr),		// ǂݏoAhX
		.creg_rd_data	(creg_rd_data),		// ǂݏof[^
		.exe_mode		(exe_mode),			// s[h
		/********** 荞 **********/
		.irq			(cpu_irq),			// 荞ݗv
		.int_detect		(int_detect),		// 荞݌o
		/********** ID/EXpCvCWX^ **********/
		.id_pc			(id_pc),			// vOJE^
		/********** MEM/WBpCvCWX^ **********/
		.mem_pc			(mem_pc),			// vOJE^
		.mem_en			(mem_en),			// pCvCf[^̗L
		.mem_br_flag	(mem_br_flag),		// tO
		.mem_ctrl_op	(mem_ctrl_op),		// 䃌WX^Iy[V
		.mem_dst_addr	(mem_dst_addr),		// ėpWX^݃AhX
		.mem_exp_code	(mem_exp_code),		// OR[h
		.mem_out		(mem_out),			// 
		/********** pCvCM **********/
		// pCvC̏
		.if_busy		(if_busy),			// IFXe[WrW[
		.ld_hazard		(ld_hazard),		// LoadnU[h
		.mem_busy		(mem_busy),			// MEMXe[WrW[
		// Xg[M
		.if_stall		(if_stall),			// IFXe[WXg[
		.id_stall		(id_stall),			// IDXe[WXg[
		.ex_stall		(ex_stall),			// EXXe[WXg[
		.mem_stall		(mem_stall),		// MEMXe[WXg[
		// tbVM
		.if_flush		(if_flush),			// IFXe[WtbV
		.id_flush		(id_flush),			// IDXe[WtbV
		.ex_flush		(ex_flush),			// EXXe[WtbV
		.mem_flush		(mem_flush),		// MEMXe[WtbV
		// VvOJE^
		.new_pc			(new_pc)			// VvOJE^
	);

	/********** ėpWX^ **********/
	gpr gpr (
		/********** NbN & Zbg **********/
		.clk	   (clk),					// NbN
		.reset	   (reset),					// 񓯊Zbg
		/********** ǂݏo|[g 0 **********/
		.rd_addr_0 (gpr_rd_addr_0),			// ǂݏoAhX
		.rd_data_0 (gpr_rd_data_0),			// ǂݏof[^
		/********** ǂݏo|[g 1 **********/
		.rd_addr_1 (gpr_rd_addr_1),			// ǂݏoAhX
		.rd_data_1 (gpr_rd_data_1),			// ǂݏof[^
		/********** ݃|[g **********/
		.we_	   (mem_gpr_we_),			// ݗL
		.wr_addr   (mem_dst_addr),			// ݃AhX
		.wr_data   (mem_out)				// ݃f[^
	);

	/********** XNb`pbh **********/
	spm spm (
		/********** NbN **********/
		.clk			 (clk_),					  // NbN
		/********** |[gA : IFXe[W **********/
		.if_spm_addr	 (if_spm_addr[`SpmAddrLoc]),  // AhX
		.if_spm_as_		 (if_spm_as_),				  // AhXXg[u
		.if_spm_rw		 (if_spm_rw),				  // ǂ݁^
		.if_spm_wr_data	 (if_spm_wr_data),			  // ݃f[^
		.if_spm_rd_data	 (if_spm_rd_data),			  // ǂݏof[^
		/********** |[gB : MEMXe[W **********/
		.mem_spm_addr	 (mem_spm_addr[`SpmAddrLoc]), // AhX
		.mem_spm_as_	 (mem_spm_as_),				  // AhXXg[u
		.mem_spm_rw		 (mem_spm_rw),				  // ǂ݁^
		.mem_spm_wr_data (mem_spm_wr_data),			  // ݃f[^
		.mem_spm_rd_data (mem_spm_rd_data)			  // ǂݏof[^
	);

endmodule
