/*
 -- ============================================================================
 -- FILE NAME	: ctrl.v
 -- DESCRIPTION : 䃆jbg
 -- ----------------------------------------------------------------------------
 -- Revision  Date		  Coding_by	 Comment
 -- 1.0.0	  2011/06/27  suito		 VK쐬
 -- ============================================================================
*/

/********** ʃwb_t@C **********/
`include "nettype.h"
`include "global_config.h"
`include "stddef.h"

/********** ʃwb_t@C **********/
`include "isa.h"
`include "cpu.h"
`include "rom.h"
`include "spm.h"

/********** W[ **********/
module ctrl (
	/********** NbN & Zbg **********/
	input  wire					  clk,			// NbN
	input  wire					  reset,		// 񓯊Zbg
	/********** 䃌WX^C^tF[X **********/
	input  wire [`RegAddrBus]	  creg_rd_addr, // ǂݏoAhX
	output reg	[`WordDataBus]	  creg_rd_data, // ǂݏof[^
	output reg	[`CpuExeModeBus]  exe_mode,		// s[h
	/********** 荞 **********/
	input  wire [`CPU_IRQ_CH-1:0] irq,			// 荞ݗv
	output reg					  int_detect,	// 荞݌o
	/********** ID/EXpCvCWX^ **********/
	input  wire [`WordAddrBus]	  id_pc,		// vOJE^
	/********** MEM/WBpCvCWX^ **********/
	input  wire [`WordAddrBus]	  mem_pc,		// vOJE^
	input  wire					  mem_en,		// pCvCf[^̗L
	input  wire					  mem_br_flag,	// tO
	input  wire [`CtrlOpBus]	  mem_ctrl_op,	// 䃌WX^Iy[V
	input  wire [`RegAddrBus]	  mem_dst_addr, // ݃AhX
	input  wire [`IsaExpBus]	  mem_exp_code, // OR[h
	input  wire [`WordDataBus]	  mem_out,		// 
	/********** pCvCM **********/
	// pCvC̏
	input  wire					  if_busy,		// IFXe[WrW[
	input  wire					  ld_hazard,	// [hnU[h
	input  wire					  mem_busy,		// MEMXe[WrW[
	// Xg[M
	output wire					  if_stall,		// IFXe[WXg[
	output wire					  id_stall,		// IDXe[WXg[
	output wire					  ex_stall,		// EXXe[WXg[
	output wire					  mem_stall,	// MEMXe[WXg[
	// tbVM
	output wire					  if_flush,		// IFXe[WtbV
	output wire					  id_flush,		// IDXe[WtbV
	output wire					  ex_flush,		// EXXe[WtbV
	output wire					  mem_flush,	// MEMXe[WtbV
	output reg	[`WordAddrBus]	  new_pc		// VvOJE^
);

	/********** 䃌WX^ **********/
	reg							 int_en;		// 0 : 荞ݗL
	reg	 [`CpuExeModeBus]		 pre_exe_mode;	// 1 : s[h
	reg							 pre_int_en;	// 1 : 荞ݗL
	reg	 [`WordAddrBus]			 epc;			// 3 : OvOJE^
	reg	 [`WordAddrBus]			 exp_vector;	// 4 : OxN^
	reg	 [`IsaExpBus]			 exp_code;		// 5 : OR[h
	reg							 dly_flag;		// 6 : fBCXbgtO
	reg	 [`CPU_IRQ_CH-1:0]		 mask;			// 7 : 荞݃}XN

	/********** M **********/
	reg [`WordAddrBus]		  pre_pc;			// ÕvOJE^
	reg						  br_flag;			// tO

	/********** pCvCM **********/
	// Xg[M
	wire   stall	 = if_busy | mem_busy;
	assign if_stall	 = stall | ld_hazard;
	assign id_stall	 = stall;
	assign ex_stall	 = stall;
	assign mem_stall = stall;
	// tbVM
	reg	   flush;
	assign if_flush	 = flush;
	assign id_flush	 = flush | ld_hazard;
	assign ex_flush	 = flush;
	assign mem_flush = flush;

	/********** pCvCtbV **********/
	always @(*) begin
		/* ftHgl */
		new_pc = `WORD_ADDR_W'h0;
		flush  = `DISABLE;
		/* pCvCtbV */
		if (mem_en == `ENABLE) begin // pCvC̃f[^L
			if (mem_exp_code != `ISA_EXP_NO_EXP) begin		 // O
				new_pc = exp_vector;
				flush  = `ENABLE;
			end else if (mem_ctrl_op == `CTRL_OP_EXRT) begin // EXRT
				new_pc = epc;
				flush  = `ENABLE;
			end else if (mem_ctrl_op == `CTRL_OP_WRCR) begin // WRCR
				new_pc = mem_pc;
				flush  = `ENABLE;
			end
		end
	end

	/********** 荞݂̌o **********/
	always @(*) begin
		if ((int_en == `ENABLE) && ((|((~mask) & irq)) == `ENABLE)) begin
			int_detect = `ENABLE;
		end else begin
			int_detect = `DISABLE;
		end
	end
   
	/********** ǂݏoANZX **********/
	always @(*) begin
		case (creg_rd_addr)
		   `CREG_ADDR_STATUS	 : begin // 0:Xe[^X
			   creg_rd_data = {{`WORD_DATA_W-2{1'b0}}, int_en, exe_mode};
		   end
		   `CREG_ADDR_PRE_STATUS : begin // 1:OÕXe[^X
			   creg_rd_data = {{`WORD_DATA_W-2{1'b0}}, 
							   pre_int_en, pre_exe_mode};
		   end
		   `CREG_ADDR_PC		 : begin // 2:vOJE^
			   creg_rd_data = {id_pc, `BYTE_OFFSET_W'h0};
		   end
		   `CREG_ADDR_EPC		 : begin // 3:OvOJE^
			   creg_rd_data = {epc, `BYTE_OFFSET_W'h0};
		   end
		   `CREG_ADDR_EXP_VECTOR : begin // 4:OxN^
			   creg_rd_data = {exp_vector, `BYTE_OFFSET_W'h0};
		   end
		   `CREG_ADDR_CAUSE		 : begin // 5:O
			   creg_rd_data = {{`WORD_DATA_W-1-`ISA_EXP_W{1'b0}}, 
							   dly_flag, exp_code};
		   end
		   `CREG_ADDR_INT_MASK	 : begin // 6:荞݃}XN
			   creg_rd_data = {{`WORD_DATA_W-`CPU_IRQ_CH{1'b0}}, mask};
		   end
		   `CREG_ADDR_IRQ		 : begin // 6:荞݌
			   creg_rd_data = {{`WORD_DATA_W-`CPU_IRQ_CH{1'b0}}, irq};
		   end
		   `CREG_ADDR_ROM_SIZE	 : begin // 7:ROM̃TCY
			   creg_rd_data = $unsigned(`ROM_SIZE);
		   end
		   `CREG_ADDR_SPM_SIZE	 : begin // 8:SPM̃TCY
			   creg_rd_data = $unsigned(`SPM_SIZE);
		   end
		   `CREG_ADDR_CPU_INFO	 : begin // 9:CPȔ
			   creg_rd_data = {`RELEASE_YEAR, `RELEASE_MONTH, 
							   `RELEASE_VERSION, `RELEASE_REVISION};
		   end
		   default				 : begin // ftHgl
			   creg_rd_data = `WORD_DATA_W'h0;
		   end
		endcase
	end

	/********** CPU̐ **********/
	always @(posedge clk or `RESET_EDGE reset) begin
		if (reset == `RESET_ENABLE) begin
			/* 񓯊Zbg */
			exe_mode	 <= #1 `CPU_KERNEL_MODE;
			int_en		 <= #1 `DISABLE;
			pre_exe_mode <= #1 `CPU_KERNEL_MODE;
			pre_int_en	 <= #1 `DISABLE;
			exp_code	 <= #1 `ISA_EXP_NO_EXP;
			mask		 <= #1 {`CPU_IRQ_CH{`ENABLE}};
			dly_flag	 <= #1 `DISABLE;
			epc			 <= #1 `WORD_ADDR_W'h0;
			exp_vector	 <= #1 `WORD_ADDR_W'h0;
			pre_pc		 <= #1 `WORD_ADDR_W'h0;
			br_flag		 <= #1 `DISABLE;
		end else begin
			/* CPȔԂXV */
			if ((mem_en == `ENABLE) && (stall == `DISABLE)) begin
				/* PCƕtO̕ۑ */
				pre_pc		 <= #1 mem_pc;
				br_flag		 <= #1 mem_br_flag;
				/* CPŨXe[^X */
				if (mem_exp_code != `ISA_EXP_NO_EXP) begin		 // O
					exe_mode	 <= #1 `CPU_KERNEL_MODE;
					int_en		 <= #1 `DISABLE;
					pre_exe_mode <= #1 exe_mode;
					pre_int_en	 <= #1 int_en;
					exp_code	 <= #1 mem_exp_code;
					dly_flag	 <= #1 br_flag;
					epc			 <= #1 pre_pc;
				end else if (mem_ctrl_op == `CTRL_OP_EXRT) begin // EXRT
					exe_mode	 <= #1 pre_exe_mode;
					int_en		 <= #1 pre_int_en;
				end else if (mem_ctrl_op == `CTRL_OP_WRCR) begin // WRCR
				   /* 䃌WX^ւ̏ */
					case (mem_dst_addr)
						`CREG_ADDR_STATUS	  : begin // Xe[^X
							exe_mode	 <= #1 mem_out[`CregExeModeLoc];
							int_en		 <= #1 mem_out[`CregIntEnableLoc];
						end
						`CREG_ADDR_PRE_STATUS : begin // OÕXe[^X
							pre_exe_mode <= #1 mem_out[`CregExeModeLoc];
							pre_int_en	 <= #1 mem_out[`CregIntEnableLoc];
						end
						`CREG_ADDR_EPC		  : begin // OvOJE^
							epc			 <= #1 mem_out[`WordAddrLoc];
						end
						`CREG_ADDR_EXP_VECTOR : begin // OxN^
							exp_vector	 <= #1 mem_out[`WordAddrLoc];
						end
						`CREG_ADDR_CAUSE	  : begin // O
							dly_flag	 <= #1 mem_out[`CregDlyFlagLoc];
							exp_code	 <= #1 mem_out[`CregExpCodeLoc];
						end
						`CREG_ADDR_INT_MASK	  : begin // 荞݃}XN
							mask		 <= #1 mem_out[`CPU_IRQ_CH-1:0];
						end
					endcase
				end
			end
		end
	end

endmodule
