/*
 -- ============================================================================
 -- FILE NAME	: decoder.v
 -- DESCRIPTION : ߃fR[_
 -- ----------------------------------------------------------------------------
 -- Revision  Date		  Coding_by	 Comment
 -- 1.0.0	  2011/06/27  suito		 VK쐬
 -- ============================================================================
*/

/********** ʃwb_t@C **********/
`include "nettype.h"
`include "global_config.h"
`include "stddef.h"

/********** ʃwb_t@C **********/
`include "isa.h"
`include "cpu.h"

/********** W[ **********/
module decoder (
	/********** IF/IDpCvCWX^ **********/
	input  wire [`WordAddrBus]	 if_pc,			 // vOJE^
	input  wire [`WordDataBus]	 if_insn,		 // 
	input  wire					 if_en,			 // pCvCf[^̗L
	/********** GPRC^tF[X **********/
	input  wire [`WordDataBus]	 gpr_rd_data_0, // ǂݏof[^ 0
	input  wire [`WordDataBus]	 gpr_rd_data_1, // ǂݏof[^ 1
	output wire [`RegAddrBus]	 gpr_rd_addr_0, // ǂݏoAhX 0
	output wire [`RegAddrBus]	 gpr_rd_addr_1, // ǂݏoAhX 1
	/********** tH[fBO **********/
	// IDXe[W̃tH[fBO
	input  wire					 id_en,			// pCvCf[^̗L
	input  wire [`RegAddrBus]	 id_dst_addr,	// ݃AhX
	input  wire					 id_gpr_we_,	// ݗL
	input  wire [`MemOpBus]		 id_mem_op,		// Iy[V
	// EXXe[W̃tH[fBO
	input  wire					 ex_en,			// pCvCf[^̗L
	input  wire [`RegAddrBus]	 ex_dst_addr,	// ݃AhX
	input  wire					 ex_gpr_we_,	// ݗL
	input  wire [`WordDataBus]	 ex_fwd_data,	// tH[fBOf[^
	// MEMXe[W̃tH[fBO
	input  wire [`WordDataBus]	 mem_fwd_data,	// tH[fBOf[^
	/********** 䃌WX^C^tF[X **********/
	input  wire [`CpuExeModeBus] exe_mode,		// s[h
	input  wire [`WordDataBus]	 creg_rd_data,	// ǂݏof[^
	output wire [`RegAddrBus]	 creg_rd_addr,	// ǂݏoAhX
	/********** fR[h **********/
	output reg	[`AluOpBus]		 alu_op,		// ALUIy[V
	output reg	[`WordDataBus]	 alu_in_0,		// ALU 0
	output reg	[`WordDataBus]	 alu_in_1,		// ALU 1
	output reg	[`WordAddrBus]	 br_addr,		// AhX
	output reg					 br_taken,		// ̐
	output reg					 br_flag,		// tO
	output reg	[`MemOpBus]		 mem_op,		// Iy[V
	output wire [`WordDataBus]	 mem_wr_data,	// ݃f[^
	output reg	[`CtrlOpBus]	 ctrl_op,		// Iy[V
	output reg	[`RegAddrBus]	 dst_addr,		// ėpWX^݃AhX
	output reg					 gpr_we_,		// ėpWX^ݗL
	output reg	[`IsaExpBus]	 exp_code,		// OR[h
	output reg					 ld_hazard		// [hnU[h
);

	/********** ߃tB[h **********/
	wire [`IsaOpBus]	op		= if_insn[`IsaOpLoc];	  // IyR[h
	wire [`RegAddrBus]	ra_addr = if_insn[`IsaRaAddrLoc]; // RaAhX
	wire [`RegAddrBus]	rb_addr = if_insn[`IsaRbAddrLoc]; // RbAhX
	wire [`RegAddrBus]	rc_addr = if_insn[`IsaRcAddrLoc]; // RcAhX
	wire [`IsaImmBus]	imm		= if_insn[`IsaImmLoc];	  // l
	/********** l **********/
	// g
	wire [`WordDataBus] imm_s = {{`ISA_EXT_W{imm[`ISA_IMM_MSB]}}, imm};
	// [g
	wire [`WordDataBus] imm_u = {{`ISA_EXT_W{1'b0}}, imm};
	/********** WX^̓ǂݏoAhX **********/
	assign gpr_rd_addr_0 = ra_addr; // ėpWX^ǂݏoAhX 0
	assign gpr_rd_addr_1 = rb_addr; // ėpWX^ǂݏoAhX 1
	assign creg_rd_addr	 = ra_addr; // 䃌WX^ǂݏoAhX
	/********** ėpWX^̓ǂݏof[^ **********/
	reg			[`WordDataBus]	ra_data;						  // ȂRa
	wire signed [`WordDataBus]	s_ra_data = $signed(ra_data);	  // tRa
	reg			[`WordDataBus]	rb_data;						  // ȂRb
	wire signed [`WordDataBus]	s_rb_data = $signed(rb_data);	  // tRb
	assign mem_wr_data = rb_data; // ݃f[^
	/********** AhX **********/
	wire [`WordAddrBus] ret_addr  = if_pc + 1'b1;					 // ߂Ԓn
	wire [`WordAddrBus] br_target = if_pc + imm_s[`WORD_ADDR_MSB:0]; // 
	wire [`WordAddrBus] jr_target = ra_data[`WordAddrLoc];		   // Wv

	/********** tH[fBO **********/
	always @(*) begin
		/* RaWX^ */
		if ((id_en == `ENABLE) && (id_gpr_we_ == `ENABLE_) && 
			(id_dst_addr == ra_addr)) begin
			ra_data = ex_fwd_data;	 // EXXe[W̃tH[fBO
		end else if ((ex_en == `ENABLE) && (ex_gpr_we_ == `ENABLE_) && 
					 (ex_dst_addr == ra_addr)) begin
			ra_data = mem_fwd_data;	 // MEMXe[W̃tH[fBO
		end else begin
			ra_data = gpr_rd_data_0; // WX^t@C̓ǂݏo
		end
		/* RbWX^ */
		if ((id_en == `ENABLE) && (id_gpr_we_ == `ENABLE_) && 
			(id_dst_addr == rb_addr)) begin
			rb_data = ex_fwd_data;	 // EXXe[W̃tH[fBO
		end else if ((ex_en == `ENABLE) && (ex_gpr_we_ == `ENABLE_) && 
					 (ex_dst_addr == rb_addr)) begin
			rb_data = mem_fwd_data;	 // MEMXe[W̃tH[fBO
		end else begin
			rb_data = gpr_rd_data_1; // WX^t@C̓ǂݏo
		end
	end

	/********** [hnU[ȟo **********/
	always @(*) begin
		if ((id_en == `ENABLE) && (id_mem_op == `MEM_OP_LDW) &&
			((id_dst_addr == ra_addr) || (id_dst_addr == rb_addr))) begin
			ld_hazard = `ENABLE;  // [hnU[h
		end else begin
			ld_hazard = `DISABLE; // nU[hȂ
		end
	end

	/********** ߂̃fR[h **********/
	always @(*) begin
		/* ftHgl */
		alu_op	 = `ALU_OP_NOP;
		alu_in_0 = ra_data;
		alu_in_1 = rb_data;
		br_taken = `DISABLE;
		br_flag	 = `DISABLE;
		br_addr	 = {`WORD_ADDR_W{1'b0}};
		mem_op	 = `MEM_OP_NOP;
		ctrl_op	 = `CTRL_OP_NOP;
		dst_addr = rb_addr;
		gpr_we_	 = `DISABLE_;
		exp_code = `ISA_EXP_NO_EXP;
		/* IyR[h̔ */
		if (if_en == `ENABLE) begin
			case (op)
				/* _Z */
				`ISA_OP_ANDR  : begin // WX^m̘_
					alu_op	 = `ALU_OP_AND;
					dst_addr = rc_addr;
					gpr_we_	 = `ENABLE_;
				end
				`ISA_OP_ANDI  : begin // WX^Ƒl̘_
					alu_op	 = `ALU_OP_AND;
					alu_in_1 = imm_u;
					gpr_we_	 = `ENABLE_;
				end
				`ISA_OP_ORR	  : begin // WX^m̘_a
					alu_op	 = `ALU_OP_OR;
					dst_addr = rc_addr;
					gpr_we_	 = `ENABLE_;
				end
				`ISA_OP_ORI	  : begin // WX^Ƒl̘_a
					alu_op	 = `ALU_OP_OR;
					alu_in_1 = imm_u;
					gpr_we_	 = `ENABLE_;
				end
				`ISA_OP_XORR  : begin // WX^m̔rI_a
					alu_op	 = `ALU_OP_XOR;
					dst_addr = rc_addr;
					gpr_we_	 = `ENABLE_;
				end
				`ISA_OP_XORI  : begin // WX^Ƒl̔rI_a
					alu_op	 = `ALU_OP_XOR;
					alu_in_1 = imm_u;
					gpr_we_	 = `ENABLE_;
				end
				/* ZpZ */
				`ISA_OP_ADDSR : begin // WX^m̕tZ
					alu_op	 = `ALU_OP_ADDS;
					dst_addr = rc_addr;
					gpr_we_	 = `ENABLE_;
				end
				`ISA_OP_ADDSI : begin // WX^Ƒl̕tZ
					alu_op	 = `ALU_OP_ADDS;
					alu_in_1 = imm_s;
					gpr_we_	 = `ENABLE_;
				end
				`ISA_OP_ADDUR : begin // WX^m̕ȂZ
					alu_op	 = `ALU_OP_ADDU;
					dst_addr = rc_addr;
					gpr_we_	 = `ENABLE_;
				end
				`ISA_OP_ADDUI : begin // WX^Ƒl̕ȂZ
					alu_op	 = `ALU_OP_ADDU;
					alu_in_1 = imm_s;
					gpr_we_	 = `ENABLE_;
				end
				`ISA_OP_SUBSR : begin // WX^m̕tZ
					alu_op	 = `ALU_OP_SUBS;
					dst_addr = rc_addr;
					gpr_we_	 = `ENABLE_;
				end
				`ISA_OP_SUBUR : begin // WX^m̕ȂZ
					alu_op	 = `ALU_OP_SUBU;
					dst_addr = rc_addr;
					gpr_we_	 = `ENABLE_;
				end
				/* Vtg */
				`ISA_OP_SHRLR : begin // WX^m̘_EVtg
					alu_op	 = `ALU_OP_SHRL;
					dst_addr = rc_addr;
					gpr_we_	 = `ENABLE_;
				end
				`ISA_OP_SHRLI : begin // WX^Ƒl̘_EVtg
					alu_op	 = `ALU_OP_SHRL;
					alu_in_1 = imm_u;
					gpr_we_	 = `ENABLE_;
				end
				`ISA_OP_SHLLR : begin // WX^m̘_Vtg
					alu_op	 = `ALU_OP_SHLL;
					dst_addr = rc_addr;
					gpr_we_	 = `ENABLE_;
				end
				`ISA_OP_SHLLI : begin // WX^Ƒl̘_Vtg
					alu_op	 = `ALU_OP_SHLL;
					alu_in_1 = imm_u;
					gpr_we_	 = `ENABLE_;
				end
				/* 򖽗 */
				`ISA_OP_BE	  : begin // WX^m̕triRa == Rbj
					br_addr	 = br_target;
					br_taken = (ra_data == rb_data) ? `ENABLE : `DISABLE;
					br_flag	 = `ENABLE;
				end
				`ISA_OP_BNE	  : begin // WX^m̕triRa != Rbj
					br_addr	 = br_target;
					br_taken = (ra_data != rb_data) ? `ENABLE : `DISABLE;
					br_flag	 = `ENABLE;
				end
				`ISA_OP_BSGT  : begin // WX^m̕triRa < Rbj
					br_addr	 = br_target;
					br_taken = (s_ra_data < s_rb_data) ? `ENABLE : `DISABLE;
					br_flag	 = `ENABLE;
				end
				`ISA_OP_BUGT  : begin // WX^m̕ȂriRa < Rbj
					br_addr	 = br_target;
					br_taken = (ra_data < rb_data) ? `ENABLE : `DISABLE;
					br_flag	 = `ENABLE;
				end
				`ISA_OP_JMP	  : begin // 
					br_addr	 = jr_target;
					br_taken = `ENABLE;
					br_flag	 = `ENABLE;
				end
				`ISA_OP_CALL  : begin // R[
					alu_in_0 = {ret_addr, {`BYTE_OFFSET_W{1'b0}}};
					br_addr	 = jr_target;
					br_taken = `ENABLE;
					br_flag	 = `ENABLE;
					dst_addr = `REG_ADDR_W'd31;
					gpr_we_	 = `ENABLE_;
				end
				/* ANZX */
				`ISA_OP_LDW	  : begin // [hǂݏo
					alu_op	 = `ALU_OP_ADDU;
					alu_in_1 = imm_s;
					mem_op	 = `MEM_OP_LDW;
					gpr_we_	 = `ENABLE_;
				end
				`ISA_OP_STW	  : begin // [h
					alu_op	 = `ALU_OP_ADDU;
					alu_in_1 = imm_s;
					mem_op	 = `MEM_OP_STW;
				end
				/* VXeR[ */
				`ISA_OP_TRAP  : begin // gbv
					exp_code = `ISA_EXP_TRAP;
				end
				/*  */
				`ISA_OP_RDCR  : begin // 䃌WX^̓ǂݏo
					if (exe_mode == `CPU_KERNEL_MODE) begin
						alu_in_0 = creg_rd_data;
						gpr_we_	 = `ENABLE_;
					end else begin
						exp_code = `ISA_EXP_PRV_VIO;
					end
				end
				`ISA_OP_WRCR  : begin // 䃌WX^ւ̏
					if (exe_mode == `CPU_KERNEL_MODE) begin
						ctrl_op	 = `CTRL_OP_WRCR;
					end else begin
						exp_code = `ISA_EXP_PRV_VIO;
					end
				end
				`ISA_OP_EXRT  : begin // O̕A
					if (exe_mode == `CPU_KERNEL_MODE) begin
						ctrl_op	 = `CTRL_OP_EXRT;
					end else begin
						exp_code = `ISA_EXP_PRV_VIO;
					end
				end
				/* ̖̑ */
				default		  : begin // `
					exp_code = `ISA_EXP_UNDEF_INSN;
				end
			endcase
		end
	end

endmodule
