/*
 -- ============================================================================
 -- FILE NAME	: ex_stage.v
 -- DESCRIPTION : EXXe[W
 -- ----------------------------------------------------------------------------
 -- Revision  Date		  Coding_by	 Comment
 -- 1.0.0	  2011/06/27  suito		 VK쐬
 -- ============================================================================
*/

/********** ʃwb_t@C **********/
`include "nettype.h"
`include "global_config.h"
`include "stddef.h"

/********** ʃwb_t@C **********/
`include "isa.h"
`include "cpu.h"

/********** W[ **********/
module ex_stage (
	/********** NbN & Zbg **********/
	input  wire				   clk,			   // NbN
	input  wire				   reset,		   // 񓯊Zbg
	/********** pCvCM **********/
	input  wire				   stall,		   // Xg[
	input  wire				   flush,		   // tbV
	input  wire				   int_detect,	   // 荞݌o
	/********** tH[fBO **********/
	output wire [`WordDataBus] fwd_data,	   // tH[fBOf[^
	/********** ID/EXpCvCWX^ **********/
	input  wire [`WordAddrBus] id_pc,		   // vOJE^
	input  wire				   id_en,		   // pCvCf[^̗L
	input  wire [`AluOpBus]	   id_alu_op,	   // ALUIy[V
	input  wire [`WordDataBus] id_alu_in_0,	   // ALU 0
	input  wire [`WordDataBus] id_alu_in_1,	   // ALU 1
	input  wire				   id_br_flag,	   // tO
	input  wire [`MemOpBus]	   id_mem_op,	   // Iy[V
	input  wire [`WordDataBus] id_mem_wr_data, // ݃f[^
	input  wire [`CtrlOpBus]   id_ctrl_op,	   // 䃌WX^Iy[V
	input  wire [`RegAddrBus]  id_dst_addr,	   // ėpWX^݃AhX
	input  wire				   id_gpr_we_,	   // ėpWX^ݗL
	input  wire [`IsaExpBus]   id_exp_code,	   // OR[h
	/********** EX/MEMpCvCWX^ **********/
	output wire [`WordAddrBus] ex_pc,		   // vOJE^
	output wire				   ex_en,		   // pCvCf[^̗L
	output wire				   ex_br_flag,	   // tO
	output wire [`MemOpBus]	   ex_mem_op,	   // Iy[V
	output wire [`WordDataBus] ex_mem_wr_data, // ݃f[^
	output wire [`CtrlOpBus]   ex_ctrl_op,	   // 䃌WX^Iy[V
	output wire [`RegAddrBus]  ex_dst_addr,	   // ėpWX^݃AhX
	output wire				   ex_gpr_we_,	   // ėpWX^ݗL
	output wire [`IsaExpBus]   ex_exp_code,	   // OR[h
	output wire [`WordDataBus] ex_out		   // 
);

	/********** ALȔo **********/
	wire [`WordDataBus]		   alu_out;		   // Z
	wire					   alu_of;		   // I[ot[

	/********** Zʂ̃tH[fBO **********/
	assign fwd_data = alu_out;

	/********** ALU **********/
	alu alu (
		.in_0			(id_alu_in_0),	  //  0
		.in_1			(id_alu_in_1),	  //  1
		.op				(id_alu_op),	  // Iy[V
		.out			(alu_out),		  // o
		.of				(alu_of)		  // I[ot[
	);

	/********** pCvCWX^ **********/
	ex_reg ex_reg (
		/********** NbN & Zbg **********/
		.clk			(clk),			  // NbN
		.reset			(reset),		  // 񓯊Zbg
		/********** ALȔo **********/
		.alu_out		(alu_out),		  // Z
		.alu_of			(alu_of),		  // I[ot[
		/********** pCvCM **********/
		.stall			(stall),		  // Xg[
		.flush			(flush),		  // tbV
		.int_detect		(int_detect),	  // 荞݌o
		/********** ID/EXpCvCWX^ **********/
		.id_pc			(id_pc),		  // vOJE^
		.id_en			(id_en),		  // pCvCf[^̗L
		.id_br_flag		(id_br_flag),	  // tO
		.id_mem_op		(id_mem_op),	  // Iy[V
		.id_mem_wr_data (id_mem_wr_data), // ݃f[^
		.id_ctrl_op		(id_ctrl_op),	  // 䃌WX^Iy[V
		.id_dst_addr	(id_dst_addr),	  // ėpWX^݃AhX
		.id_gpr_we_		(id_gpr_we_),	  // ėpWX^ݗL
		.id_exp_code	(id_exp_code),	  // OR[h
		/********** EX/MEMpCvCWX^ **********/
		.ex_pc			(ex_pc),		  // vOJE^
		.ex_en			(ex_en),		  // pCvCf[^̗L
		.ex_br_flag		(ex_br_flag),	  // tO
		.ex_mem_op		(ex_mem_op),	  // Iy[V
		.ex_mem_wr_data (ex_mem_wr_data), // ݃f[^
		.ex_ctrl_op		(ex_ctrl_op),	  // 䃌WX^Iy[V
		.ex_dst_addr	(ex_dst_addr),	  // ėpWX^݃AhX
		.ex_gpr_we_		(ex_gpr_we_),	  // ėpWX^ݗL
		.ex_exp_code	(ex_exp_code),	  // OR[h
		.ex_out			(ex_out)		  // 
	);

endmodule
