/* 
 -- ============================================================================
 -- FILE NAME	: gpr.v
 -- DESCRIPTION : ėpWX^
 -- ----------------------------------------------------------------------------
 -- Revision  Date		  Coding_by	 Comment
 -- 1.0.0	  2011/06/27  suito		 VK쐬
 -- ============================================================================
*/

/********** ʃwb_t@C **********/
`include "nettype.h"
`include "global_config.h"
`include "stddef.h"

/********** ʃwb_t@C **********/
`include "cpu.h"

/********** W[ **********/
module gpr (
	/********** NbN & Zbg **********/
	input  wire				   clk,				   // NbN
	input  wire				   reset,			   // 񓯊Zbg
	/********** ǂݏo|[g 0 **********/
	input  wire [`RegAddrBus]  rd_addr_0,		   // ǂݏoAhX
	output wire [`WordDataBus] rd_data_0,		   // ǂݏof[^
	/********** ǂݏo|[g 1 **********/
	input  wire [`RegAddrBus]  rd_addr_1,		   // ǂݏoAhX
	output wire [`WordDataBus] rd_data_1,		   // ǂݏof[^
	/********** ݃|[g **********/
	input  wire				   we_,				   // ݗL
	input  wire [`RegAddrBus]  wr_addr,			   // ݃AhX
	input  wire [`WordDataBus] wr_data			   // ݃f[^
);

	/********** M **********/
	reg [`WordDataBus]		   gpr [`REG_NUM-1:0]; // WX^z
	integer					   i;				   // Ce[^

	/********** ǂݏoANZX (Write After Read) **********/
	// ǂݏo|[g 0
	assign rd_data_0 = ((we_ == `ENABLE_) && (wr_addr == rd_addr_0)) ? 
					   wr_data : gpr[rd_addr_0];
	// ǂݏo|[g 1
	assign rd_data_1 = ((we_ == `ENABLE_) && (wr_addr == rd_addr_1)) ? 
					   wr_data : gpr[rd_addr_1];
   
	/********** ݃ANZX **********/
	always @ (posedge clk or `RESET_EDGE reset) begin
		if (reset == `RESET_ENABLE) begin 
			/* 񓯊Zbg */
			for (i = 0; i < `REG_NUM; i = i + 1) begin
				gpr[i]		 <= #1 `WORD_DATA_W'h0;
			end
		end else begin
			/* ݃ANZX */
			if (we_ == `ENABLE_) begin 
				gpr[wr_addr] <= #1 wr_data;
			end
		end
	end

endmodule 
