/* 
 -- ============================================================================
 -- FILE NAME	: id_reg.v
 -- DESCRIPTION : IDXe[WpCvCWX^
 -- ----------------------------------------------------------------------------
 -- Revision  Date		  Coding_by	 Comment
 -- 1.0.0	  2011/06/27  suito		 VK쐬
 -- ============================================================================
*/

/********** ʃwb_t@C **********/
`include "nettype.h"
`include "global_config.h"
`include "stddef.h"

/********** ʃwb_t@C **********/
`include "isa.h"
`include "cpu.h"

/********** W[ **********/
module id_reg (
	/********** NbN & Zbg **********/
	input  wire				   clk,			   // NbN
	input  wire				   reset,		   // 񓯊Zbg
	/********** fR[h **********/
	input  wire [`AluOpBus]	   alu_op,		   // ALUIy[V
	input  wire [`WordDataBus] alu_in_0,	   // ALU 0
	input  wire [`WordDataBus] alu_in_1,	   // ALU 1
	input  wire				   br_flag,		   // tO
	input  wire [`MemOpBus]	   mem_op,		   // Iy[V
	input  wire [`WordDataBus] mem_wr_data,	   // ݃f[^
	input  wire [`CtrlOpBus]   ctrl_op,		   // Iy[V
	input  wire [`RegAddrBus]  dst_addr,	   // ėpWX^݃AhX
	input  wire				   gpr_we_,		   // ėpWX^ݗL
	input  wire [`IsaExpBus]   exp_code,	   // OR[h
	/********** pCvCM **********/
	input  wire				   stall,		   // Xg[
	input  wire				   flush,		   // tbV
	/********** IF/IDpCvCWX^ **********/
	input  wire [`WordAddrBus] if_pc,		   // vOJE^
	input  wire				   if_en,		   // pCvCf[^̗L
	/********** ID/EXpCvCWX^ **********/
	output reg	[`WordAddrBus] id_pc,		   // vOJE^
	output reg				   id_en,		   // pCvCf[^̗L
	output reg	[`AluOpBus]	   id_alu_op,	   // ALUIy[V
	output reg	[`WordDataBus] id_alu_in_0,	   // ALU 0
	output reg	[`WordDataBus] id_alu_in_1,	   // ALU 1
	output reg				   id_br_flag,	   // tO
	output reg	[`MemOpBus]	   id_mem_op,	   // Iy[V
	output reg	[`WordDataBus] id_mem_wr_data, // ݃f[^
	output reg	[`CtrlOpBus]   id_ctrl_op,	   // Iy[V
	output reg	[`RegAddrBus]  id_dst_addr,	   // ėpWX^݃AhX
	output reg				   id_gpr_we_,	   // ėpWX^ݗL
	output reg [`IsaExpBus]	   id_exp_code	   // OR[h
);

	/********** pCvCWX^ **********/
	always @(posedge clk or `RESET_EDGE reset) begin
		if (reset == `RESET_ENABLE) begin 
			/* 񓯊Zbg */
			id_pc		   <= #1 `WORD_ADDR_W'h0;
			id_en		   <= #1 `DISABLE;
			id_alu_op	   <= #1 `ALU_OP_NOP;
			id_alu_in_0	   <= #1 `WORD_DATA_W'h0;
			id_alu_in_1	   <= #1 `WORD_DATA_W'h0;
			id_br_flag	   <= #1 `DISABLE;
			id_mem_op	   <= #1 `MEM_OP_NOP;
			id_mem_wr_data <= #1 `WORD_DATA_W'h0;
			id_ctrl_op	   <= #1 `CTRL_OP_NOP;
			id_dst_addr	   <= #1 `REG_ADDR_W'd0;
			id_gpr_we_	   <= #1 `DISABLE_;
			id_exp_code	   <= #1 `ISA_EXP_NO_EXP;
		end else begin
			/* pCvCWX^̍XV */
			if (stall == `DISABLE) begin 
				if (flush == `ENABLE) begin // tbV
				   id_pc		  <= #1 `WORD_ADDR_W'h0;
				   id_en		  <= #1 `DISABLE;
				   id_alu_op	  <= #1 `ALU_OP_NOP;
				   id_alu_in_0	  <= #1 `WORD_DATA_W'h0;
				   id_alu_in_1	  <= #1 `WORD_DATA_W'h0;
				   id_br_flag	  <= #1 `DISABLE;
				   id_mem_op	  <= #1 `MEM_OP_NOP;
				   id_mem_wr_data <= #1 `WORD_DATA_W'h0;
				   id_ctrl_op	  <= #1 `CTRL_OP_NOP;
				   id_dst_addr	  <= #1 `REG_ADDR_W'd0;
				   id_gpr_we_	  <= #1 `DISABLE_;
				   id_exp_code	  <= #1 `ISA_EXP_NO_EXP;
				end else begin				// ̃f[^
				   id_pc		  <= #1 if_pc;
				   id_en		  <= #1 if_en;
				   id_alu_op	  <= #1 alu_op;
				   id_alu_in_0	  <= #1 alu_in_0;
				   id_alu_in_1	  <= #1 alu_in_1;
				   id_br_flag	  <= #1 br_flag;
				   id_mem_op	  <= #1 mem_op;
				   id_mem_wr_data <= #1 mem_wr_data;
				   id_ctrl_op	  <= #1 ctrl_op;
				   id_dst_addr	  <= #1 dst_addr;
				   id_gpr_we_	  <= #1 gpr_we_;
				   id_exp_code	  <= #1 exp_code;
				end
			end
		end
	end

endmodule
