/*
 -- ============================================================================
 -- FILE NAME	: id_stage.v
 -- DESCRIPTION : IDXe[W
 -- ----------------------------------------------------------------------------
 -- Revision  Date		  Coding_by	 Comment
 -- 1.0.0	  2011/06/27  suito		 VK쐬
 -- ============================================================================
*/

/********** ʃwb_t@C **********/
`include "nettype.h"
`include "global_config.h"
`include "stddef.h"

/********** ʃwb_t@C **********/
`include "isa.h"
`include "cpu.h"

/********** W[ **********/
module id_stage (
	/********** NbN & Zbg **********/
	input  wire					 clk,			 // NbN
	input  wire					 reset,			 // 񓯊Zbg
	/********** GPRC^tF[X **********/
	input  wire [`WordDataBus]	 gpr_rd_data_0,	 // ǂݏof[^ 0
	input  wire [`WordDataBus]	 gpr_rd_data_1,	 // ǂݏof[^ 1
	output wire [`RegAddrBus]	 gpr_rd_addr_0,	 // ǂݏoAhX 0
	output wire [`RegAddrBus]	 gpr_rd_addr_1,	 // ǂݏoAhX 1
	/********** tH[fBO **********/
	// EXXe[W̃tH[fBO
	input  wire					 ex_en,			// pCvCf[^̗L
	input  wire [`WordDataBus]	 ex_fwd_data,	 // tH[fBOf[^
	input  wire [`RegAddrBus]	 ex_dst_addr,	 // ݃AhX
	input  wire					 ex_gpr_we_,	 // ݗL
	// MEMXe[W̃tH[fBO
	input  wire [`WordDataBus]	 mem_fwd_data,	 // tH[fBOf[^
	/********** 䃌WX^C^tF[X **********/
	input  wire [`CpuExeModeBus] exe_mode,		 // s[h
	input  wire [`WordDataBus]	 creg_rd_data,	 // ǂݏof[^
	output wire [`RegAddrBus]	 creg_rd_addr,	 // ǂݏoAhX
	/********** pCvCM **********/
	input  wire					 stall,			 // Xg[
	input  wire					 flush,			 // tbV
	output wire [`WordAddrBus]	 br_addr,		 // AhX
	output wire					 br_taken,		 // ̐
	output wire					 ld_hazard,		 // [hnU[h
	/********** IF/IDpCvCWX^ **********/
	input  wire [`WordAddrBus]	 if_pc,			 // vOJE^
	input  wire [`WordDataBus]	 if_insn,		 // 
	input  wire					 if_en,			 // pCvCf[^̗L
	/********** ID/EXpCvCWX^ **********/
	output wire [`WordAddrBus]	 id_pc,			 // vOJE^
	output wire					 id_en,			 // pCvCf[^̗L
	output wire [`AluOpBus]		 id_alu_op,		 // ALUIy[V
	output wire [`WordDataBus]	 id_alu_in_0,	 // ALU 0
	output wire [`WordDataBus]	 id_alu_in_1,	 // ALU 1
	output wire					 id_br_flag,	 // tO
	output wire [`MemOpBus]		 id_mem_op,		 // Iy[V
	output wire [`WordDataBus]	 id_mem_wr_data, // ݃f[^
	output wire [`CtrlOpBus]	 id_ctrl_op,	 // Iy[V
	output wire [`RegAddrBus]	 id_dst_addr,	 // GPR݃AhX
	output wire					 id_gpr_we_,	 // GPRݗL
	output wire [`IsaExpBus]	 id_exp_code	 // OR[h
);

	/********** fR[hM **********/
	wire  [`AluOpBus]			 alu_op;		 // ALUIy[V
	wire  [`WordDataBus]		 alu_in_0;		 // ALU 0
	wire  [`WordDataBus]		 alu_in_1;		 // ALU 1
	wire						 br_flag;		 // tO
	wire  [`MemOpBus]			 mem_op;		 // Iy[V
	wire  [`WordDataBus]		 mem_wr_data;	 // ݃f[^
	wire  [`CtrlOpBus]			 ctrl_op;		 // Iy[V
	wire  [`RegAddrBus]			 dst_addr;		 // GPR݃AhX
	wire						 gpr_we_;		 // GPRݗL
	wire  [`IsaExpBus]			 exp_code;		 // OR[h

	/********** fR[_ **********/
	decoder decoder (
		/********** IF/IDpCvCWX^ **********/
		.if_pc			(if_pc),		  // vOJE^
		.if_insn		(if_insn),		  // 
		.if_en			(if_en),		  // pCvCf[^̗L
		/********** GPRC^tF[X **********/
		.gpr_rd_data_0	(gpr_rd_data_0),  // ǂݏof[^ 0
		.gpr_rd_data_1	(gpr_rd_data_1),  // ǂݏof[^ 1
		.gpr_rd_addr_0	(gpr_rd_addr_0),  // ǂݏoAhX 0
		.gpr_rd_addr_1	(gpr_rd_addr_1),  // ǂݏoAhX 1
		/********** tH[fBO **********/
		// IDXe[W̃tH[fBO
		.id_en			(id_en),		  // pCvCf[^̗L
		.id_dst_addr	(id_dst_addr),	  // ݃AhX
		.id_gpr_we_		(id_gpr_we_),	  // ݗL
		.id_mem_op		(id_mem_op),	  // Iy[V
		// EXXe[W̃tH[fBO
		.ex_en			(ex_en),		  // pCvCf[^̗L
		.ex_fwd_data	(ex_fwd_data),	  // tH[fBOf[^
		.ex_dst_addr	(ex_dst_addr),	  // ݃AhX
		.ex_gpr_we_		(ex_gpr_we_),	  // ݗL
		// MEMXe[W̃tH[fBO
		.mem_fwd_data	(mem_fwd_data),	  // tH[fBOf[^
		/********** 䃌WX^C^tF[X **********/
		.exe_mode		(exe_mode),		  // s[h
		.creg_rd_data	(creg_rd_data),	  // ǂݏof[^
		.creg_rd_addr	(creg_rd_addr),	  // ǂݏoAhX
		/********** fR[hM **********/
		.alu_op			(alu_op),		  // ALUIy[V
		.alu_in_0		(alu_in_0),		  // ALU 0
		.alu_in_1		(alu_in_1),		  // ALU 1
		.br_addr		(br_addr),		  // AhX
		.br_taken		(br_taken),		  // ̐
		.br_flag		(br_flag),		  // tO
		.mem_op			(mem_op),		  // Iy[V
		.mem_wr_data	(mem_wr_data),	  // ݃f[^
		.ctrl_op		(ctrl_op),		  // Iy[V
		.dst_addr		(dst_addr),		  // ėpWX^݃AhX
		.gpr_we_		(gpr_we_),		  // ėpWX^ݗL
		.exp_code		(exp_code),		  // OR[h
		.ld_hazard		(ld_hazard)		  // [hnU[h
	);

	/********** pCvCWX^ **********/
	id_reg id_reg (
		/********** NbN & Zbg **********/
		.clk			(clk),			  // NbN
		.reset			(reset),		  // 񓯊Zbg
		/********** fR[h **********/
		.alu_op			(alu_op),		  // ALUIy[V
		.alu_in_0		(alu_in_0),		  // ALU 0
		.alu_in_1		(alu_in_1),		  // ALU 1
		.br_flag		(br_flag),		  // tO
		.mem_op			(mem_op),		  // Iy[V
		.mem_wr_data	(mem_wr_data),	  // ݃f[^
		.ctrl_op		(ctrl_op),		  // Iy[V
		.dst_addr		(dst_addr),		  // ėpWX^݃AhX
		.gpr_we_		(gpr_we_),		  // ėpWX^ݗL
		.exp_code		(exp_code),		  // OR[h
		/********** pCvCM **********/
		.stall			(stall),		  // Xg[
		.flush			(flush),		  // tbV
		/********** IF/IDpCvCWX^ **********/
		.if_pc			(if_pc),		  // vOJE^
		.if_en			(if_en),		  // pCvCf[^̗L
		/********** ID/EXpCvCWX^ **********/
		.id_pc			(id_pc),		  // vOJE^
		.id_en			(id_en),		  // pCvCf[^̗L
		.id_alu_op		(id_alu_op),	  // ALUIy[V
		.id_alu_in_0	(id_alu_in_0),	  // ALU 0
		.id_alu_in_1	(id_alu_in_1),	  // ALU 1
		.id_br_flag		(id_br_flag),	  // tO
		.id_mem_op		(id_mem_op),	  // Iy[V
		.id_mem_wr_data (id_mem_wr_data), // ݃f[^
		.id_ctrl_op		(id_ctrl_op),	  // Iy[V
		.id_dst_addr	(id_dst_addr),	  // ėpWX^݃AhX
		.id_gpr_we_		(id_gpr_we_),	  // ėpWX^ݗL
		.id_exp_code	(id_exp_code)	  // OR[h
	);

endmodule
