/*
 -- ============================================================================
 -- FILE NAME	: if_reg.v
 -- DESCRIPTION : IFXe[WpCvCWX^
 -- ----------------------------------------------------------------------------
 -- Revision  Date		  Coding_by	 Comment
 -- 1.0.0	  2011/06/27  suito		 VK쐬
 -- ============================================================================
*/

/********** ʃwb_t@C **********/
`include "nettype.h"
`include "global_config.h"
`include "stddef.h"

/********** ʃwb_t@C **********/
`include "isa.h"
`include "cpu.h"

/********** W[ **********/
module if_reg (
	/********** NbN & Zbg **********/
	input  wire				   clk,		   // NbN
	input  wire				   reset,	   // 񓯊Zbg
	/********** tFb`f[^ **********/
	input  wire [`WordDataBus] insn,	   // tFb`
	/********** pCvCM **********/
	input  wire				   stall,	   // Xg[
	input  wire				   flush,	   // tbV
	input  wire [`WordAddrBus] new_pc,	   // VvOJE^
	input  wire				   br_taken,   // ̐
	input  wire [`WordAddrBus] br_addr,	   // AhX
	/********** IF/IDpCvCWX^ **********/
	output reg	[`WordAddrBus] if_pc,	   // vOJE^
	output reg	[`WordDataBus] if_insn,	   // 
	output reg				   if_en	   // pCvCf[^̗L
);

	/********** pCvCWX^ **********/
	always @(posedge clk or `RESET_EDGE reset) begin
		if (reset == `RESET_ENABLE) begin 
			/* 񓯊Zbg */
			if_pc	<= #1 `RESET_VECTOR;
			if_insn <= #1 `ISA_NOP;
			if_en	<= #1 `DISABLE;
		end else begin
			/* pCvCWX^̍XV */
			if (stall == `DISABLE) begin 
				if (flush == `ENABLE) begin				// tbV
					if_pc	<= #1 new_pc;
					if_insn <= #1 `ISA_NOP;
					if_en	<= #1 `DISABLE;
				end else if (br_taken == `ENABLE) begin // ̐
					if_pc	<= #1 br_addr;
					if_insn <= #1 insn;
					if_en	<= #1 `ENABLE;
				end else begin							// ̃AhX
					if_pc	<= #1 if_pc + 1'd1;
					if_insn <= #1 insn;
					if_en	<= #1 `ENABLE;
				end
			end
		end
	end

endmodule
