/*
 -- ============================================================================
 -- FILE NAME	: if_stage.v
 -- DESCRIPTION : IFXe[W
 -- ----------------------------------------------------------------------------
 -- Revision  Date		  Coding_by	 Comment
 -- 1.0.0	  2011/06/27  suito		 VK쐬
 -- ============================================================================
*/

/********** ʃwb_t@C **********/
`include "nettype.h"
`include "global_config.h"
`include "stddef.h"

/********** ʃwb_t@C **********/
`include "cpu.h"

/********** W[ **********/
module if_stage (
	/********** NbN & Zbg **********/
	input  wire				   clk,			// NbN
	input  wire				   reset,		// 񓯊Zbg
	/********** SPMC^tF[X **********/
	input  wire [`WordDataBus] spm_rd_data, // ǂݏof[^
	output wire [`WordAddrBus] spm_addr,	// AhX
	output wire				   spm_as_,		// AhXXg[u
	output wire				   spm_rw,		// ǂ݁^
	output wire [`WordDataBus] spm_wr_data, // ݃f[^
	/********** oXC^tF[X **********/
	input  wire [`WordDataBus] bus_rd_data, // ǂݏof[^
	input  wire				   bus_rdy_,	// fB
	input  wire				   bus_grnt_,	// oXOg
	output wire				   bus_req_,	// oXNGXg
	output wire [`WordAddrBus] bus_addr,	// AhX
	output wire				   bus_as_,		// AhXXg[u
	output wire				   bus_rw,		// ǂ݁^
	output wire [`WordDataBus] bus_wr_data, // ݃f[^
	/********** pCvCM **********/
	input  wire				   stall,		// Xg[
	input  wire				   flush,		// tbV
	input  wire [`WordAddrBus] new_pc,		// VvOJE^
	input  wire				   br_taken,	// ̐
	input  wire [`WordAddrBus] br_addr,		// AhX
	output wire				   busy,		// rW[M
	/********** IF/IDpCvCWX^ **********/
	output wire [`WordAddrBus] if_pc,		// vOJE^
	output wire [`WordDataBus] if_insn,		// 
	output wire				   if_en		// pCvCf[^̗L
);

	/********** ڑM **********/
	wire [`WordDataBus]		   insn;		// tFb`

	/********** oXC^tF[X **********/
	bus_if bus_if (
		/********** NbN & Zbg **********/
		.clk		 (clk),					// NbN
		.reset		 (reset),				// 񓯊Zbg
		/********** pCvCM **********/
		.stall		 (stall),				// Xg[
		.flush		 (flush),				// tbVM
		.busy		 (busy),				// rW[M
		/********** CPUC^tF[X **********/
		.addr		 (if_pc),				// AhX
		.as_		 (`ENABLE_),			// AhXL
		.rw			 (`READ),				// ǂ݁^
		.wr_data	 (`WORD_DATA_W'h0),		// ݃f[^
		.rd_data	 (insn),				// ǂݏof[^
		/********** XNb`pbhC^tF[X **********/
		.spm_rd_data (spm_rd_data),			// ǂݏof[^
		.spm_addr	 (spm_addr),			// AhX
		.spm_as_	 (spm_as_),				// AhXXg[u
		.spm_rw		 (spm_rw),				// ǂ݁^
		.spm_wr_data (spm_wr_data),			// ݃f[^
		/********** oXC^tF[X **********/
		.bus_rd_data (bus_rd_data),			// ǂݏof[^
		.bus_rdy_	 (bus_rdy_),			// fB
		.bus_grnt_	 (bus_grnt_),			// oXOg
		.bus_req_	 (bus_req_),			// oXNGXg
		.bus_addr	 (bus_addr),			// AhX
		.bus_as_	 (bus_as_),				// AhXXg[u
		.bus_rw		 (bus_rw),				// ǂ݁^
		.bus_wr_data (bus_wr_data)			// ݃f[^
	);
   
	/********** IFXe[WpCvCWX^ **********/
	if_reg if_reg (
		/********** NbN & Zbg **********/
		.clk		 (clk),					// NbN
		.reset		 (reset),				// 񓯊Zbg
		/********** tFb`f[^ **********/
		.insn		 (insn),				// tFb`
		/********** pCvCM **********/
		.stall		 (stall),				// Xg[
		.flush		 (flush),				// tbV
		.new_pc		 (new_pc),				// VvOJE^
		.br_taken	 (br_taken),			// ̐
		.br_addr	 (br_addr),				// AhX
		/********** IF/IDpCvCWX^ **********/
		.if_pc		 (if_pc),				// vOJE^
		.if_insn	 (if_insn),				// 
		.if_en		 (if_en)				// pCvCf[^̗L
	);

endmodule
