/*
 -- ============================================================================
 -- FILE NAME	: mem_ctrl.v
 -- DESCRIPTION : ANZX䃆jbg
 -- ----------------------------------------------------------------------------
 -- Revision  Date		  Coding_by	 Comment
 -- 1.0.0	  2011/06/27  suito		 VK쐬
 -- ============================================================================
*/

/********** ʃwb_t@C **********/
`include "nettype.h"
`include "global_config.h"
`include "stddef.h"

/********** ʃwb_t@C **********/
`include "isa.h"
`include "cpu.h"
`include "bus.h"

/********** W[ **********/
module mem_ctrl (
	/********** EX/MEMpCvCWX^ **********/
	input  wire				   ex_en,		   // pCvCf[^̗L
	input  wire [`MemOpBus]	   ex_mem_op,	   // Iy[V
	input  wire [`WordDataBus] ex_mem_wr_data, // ݃f[^
	input  wire [`WordDataBus] ex_out,		   // 
	/********** ANZXC^tF[X **********/
	input  wire [`WordDataBus] rd_data,		   // ǂݏof[^
	output wire [`WordAddrBus] addr,		   // AhX
	output reg				   as_,			   // AhXL
	output reg				   rw,			   // ǂ݁^
	output wire [`WordDataBus] wr_data,		   // ݃f[^
	/********** ANZX **********/
	output reg [`WordDataBus]  out	 ,		   // ANZX
	output reg				   miss_align	   // ~XAC
);

	/********** M **********/
	wire [`ByteOffsetBus]	 offset;		   // ItZbg

	/********** o͂̃ATC **********/
	assign wr_data = ex_mem_wr_data;		   // ݃f[^
	assign addr	   = ex_out[`WordAddrLoc];	   // AhX
	assign offset  = ex_out[`ByteOffsetLoc];   // ItZbg

	/********** ANZX̐ **********/
	always @(*) begin
		/* ftHgl */
		miss_align = `DISABLE;
		out		   = `WORD_DATA_W'h0;
		as_		   = `DISABLE_;
		rw		   = `READ;
		/* ANZX */
		if (ex_en == `ENABLE) begin
			case (ex_mem_op)
				`MEM_OP_LDW : begin // [hǂݏo
					/* oCgItZbg̃`FbN */
					if (offset == `BYTE_OFFSET_WORD) begin // AC
						out			= rd_data;
						as_		   = `ENABLE_;
					end else begin						   // ~XAC
						miss_align	= `ENABLE;
					end
				end
				`MEM_OP_STW : begin // [h
					/* oCgItZbg̃`FbN */
					if (offset == `BYTE_OFFSET_WORD) begin // AC
						rw			= `WRITE;
						as_		   = `ENABLE_;
					end else begin						   // ~XAC
						miss_align	= `ENABLE;
					end
				end
				default		: begin // ANZXȂ
					out			= ex_out;
				end
			endcase
		end
	end

endmodule
