/*
 -- ============================================================================
 -- FILE NAME	: mem_reg.v
 -- DESCRIPTION : MEMXe[WpCvCWX^
 -- ----------------------------------------------------------------------------
 -- Revision  Date		  Coding_by	 Comment
 -- 1.0.0	  2011/06/27  suito		 VK쐬
 -- ============================================================================
*/

/********** ʃwb_t@C **********/
`include "nettype.h"
`include "global_config.h"
`include "stddef.h"

/********** ʃwb_t@C **********/
`include "isa.h"
`include "cpu.h"

/********** W[ **********/
module mem_reg (
	/********** NbN & Zbg **********/
	input  wire				   clk,			 // NbN
	input  wire				   reset,		 // 񓯊Zbg
	/********** ANZX **********/
	input  wire [`WordDataBus] out,			 // ANZX
	input  wire				   miss_align,	 // ~XAC
	/********** pCvCM **********/
	input  wire				   stall,		 // Xg[
	input  wire				   flush,		 // tbV
	/********** EX/MEMpCvCWX^ **********/
	input  wire [`WordAddrBus] ex_pc,		 // vOJE^
	input  wire				   ex_en,		 // pCvCf[^̗L
	input  wire				   ex_br_flag,	 // tO
	input  wire [`CtrlOpBus]   ex_ctrl_op,	 // 䃌WX^Iy[V
	input  wire [`RegAddrBus]  ex_dst_addr,	 // ėpWX^݃AhX
	input  wire				   ex_gpr_we_,	 // ėpWX^ݗL
	input  wire [`IsaExpBus]   ex_exp_code,	 // OR[h
	/********** MEM/WBpCvCWX^ **********/
	output reg	[`WordAddrBus] mem_pc,		 // vOJE^
	output reg				   mem_en,		 // pCvCf[^̗L
	output reg				   mem_br_flag,	 // tO
	output reg	[`CtrlOpBus]   mem_ctrl_op,	 // 䃌WX^Iy[V
	output reg	[`RegAddrBus]  mem_dst_addr, // ėpWX^݃AhX
	output reg				   mem_gpr_we_,	 // ėpWX^ݗL
	output reg	[`IsaExpBus]   mem_exp_code, // OR[h
	output reg	[`WordDataBus] mem_out		 // 
);

	/********** pCvCWX^ **********/
	always @(posedge clk or `RESET_EDGE reset) begin
		if (reset == `RESET_ENABLE) begin	 
			/* 񓯊Zbg */
			mem_pc		 <= #1 `WORD_ADDR_W'h0;
			mem_en		 <= #1 `DISABLE;
			mem_br_flag	 <= #1 `DISABLE;
			mem_ctrl_op	 <= #1 `CTRL_OP_NOP;
			mem_dst_addr <= #1 `REG_ADDR_W'h0;
			mem_gpr_we_	 <= #1 `DISABLE_;
			mem_exp_code <= #1 `ISA_EXP_NO_EXP;
			mem_out		 <= #1 `WORD_DATA_W'h0;
		end else begin
			if (stall == `DISABLE) begin 
				/* pCvCWX^̍XV */
				if (flush == `ENABLE) begin				  // tbV
					mem_pc		 <= #1 `WORD_ADDR_W'h0;
					mem_en		 <= #1 `DISABLE;
					mem_br_flag	 <= #1 `DISABLE;
					mem_ctrl_op	 <= #1 `CTRL_OP_NOP;
					mem_dst_addr <= #1 `REG_ADDR_W'h0;
					mem_gpr_we_	 <= #1 `DISABLE_;
					mem_exp_code <= #1 `ISA_EXP_NO_EXP;
					mem_out		 <= #1 `WORD_DATA_W'h0;
				end else if (miss_align == `ENABLE) begin // ~XACO
					mem_pc		 <= #1 ex_pc;
					mem_en		 <= #1 ex_en;
					mem_br_flag	 <= #1 ex_br_flag;
					mem_ctrl_op	 <= #1 `CTRL_OP_NOP;
					mem_dst_addr <= #1 `REG_ADDR_W'h0;
					mem_gpr_we_	 <= #1 `DISABLE_;
					mem_exp_code <= #1 `ISA_EXP_MISS_ALIGN;
					mem_out		 <= #1 `WORD_DATA_W'h0;
				end else begin							  // ̃f[^
					mem_pc		 <= #1 ex_pc;
					mem_en		 <= #1 ex_en;
					mem_br_flag	 <= #1 ex_br_flag;
					mem_ctrl_op	 <= #1 ex_ctrl_op;
					mem_dst_addr <= #1 ex_dst_addr;
					mem_gpr_we_	 <= #1 ex_gpr_we_;
					mem_exp_code <= #1 ex_exp_code;
					mem_out		 <= #1 out;
				end
			end
		end
	end

endmodule
