/*
 -- ============================================================================
 -- FILE NAME	: mem_stage.v
 -- DESCRIPTION : MEMXe[W
 -- ----------------------------------------------------------------------------
 -- Revision  Date		  Coding_by	 Comment
 -- 1.0.0	  2011/06/27  suito		 VK쐬
 -- ============================================================================
*/

/********** ʃwb_t@C **********/
`include "nettype.h"
`include "global_config.h"
`include "stddef.h"

/********** ʃwb_t@C **********/
`include "isa.h"
`include "cpu.h"

/********** W[ **********/
module mem_stage (
	/********** NbN & Zbg **********/
	input  wire				   clk,			   // NbN
	input  wire				   reset,		   // 񓯊Zbg
	/********** pCvCM **********/
	input  wire				   stall,		   // Xg[
	input  wire				   flush,		   // tbV
	output wire				   busy,		   // rW[M
	/********** tH[fBO **********/
	output wire [`WordDataBus] fwd_data,	   // tH[fBOf[^
	/********** SPMC^tF[X **********/
	input  wire [`WordDataBus] spm_rd_data,	   // ǂݏof[^
	output wire [`WordAddrBus] spm_addr,	   // AhX
	output wire				   spm_as_,		   // AhXXg[u
	output wire				   spm_rw,		   // ǂ݁^
	output wire [`WordDataBus] spm_wr_data,	   // ݃f[^
	/********** oXC^tF[X **********/
	input  wire [`WordDataBus] bus_rd_data,	   // ǂݏof[^
	input  wire				   bus_rdy_,	   // fB
	input  wire				   bus_grnt_,	   // oXOg
	output wire				   bus_req_,	   // oXNGXg
	output wire [`WordAddrBus] bus_addr,	   // AhX
	output wire				   bus_as_,		   // AhXXg[u
	output wire				   bus_rw,		   // ǂ݁^
	output wire [`WordDataBus] bus_wr_data,	   // ݃f[^
	/********** EX/MEMpCvCWX^ **********/
	input  wire [`WordAddrBus] ex_pc,		   // vOJE^
	input  wire				   ex_en,		   // pCvCf[^̗L
	input  wire				   ex_br_flag,	   // tO
	input  wire [`MemOpBus]	   ex_mem_op,	   // Iy[V
	input  wire [`WordDataBus] ex_mem_wr_data, // ݃f[^
	input  wire [`CtrlOpBus]   ex_ctrl_op,	   // 䃌WX^Iy[V
	input  wire [`RegAddrBus]  ex_dst_addr,	   // ėpWX^݃AhX
	input  wire				   ex_gpr_we_,	   // ėpWX^ݗL
	input  wire [`IsaExpBus]   ex_exp_code,	   // OR[h
	input  wire [`WordDataBus] ex_out,		   // 
	/********** MEM/WBpCvCWX^ **********/
	output wire [`WordAddrBus] mem_pc,		   // vOJE^
	output wire				   mem_en,		   // pCvCf[^̗L
	output wire				   mem_br_flag,	   // tO
	output wire [`CtrlOpBus]   mem_ctrl_op,	   // 䃌WX^Iy[V
	output wire [`RegAddrBus]  mem_dst_addr,   // ėpWX^݃AhX
	output wire				   mem_gpr_we_,	   // ėpWX^ݗL
	output wire [`IsaExpBus]   mem_exp_code,   // OR[h
	output wire [`WordDataBus] mem_out		   // 
);

	/********** M **********/
	wire [`WordDataBus]		   rd_data;		   // ǂݏof[^
	wire [`WordAddrBus]		   addr;		   // AhX
	wire					   as_;			   // AhXL
	wire					   rw;			   // ǂ݁^
	wire [`WordDataBus]		   wr_data;		   // ݃f[^
	wire [`WordDataBus]		   out;			   // ANZX
	wire					   miss_align;	   // ~XAC

	/********** ʂ̃tH[fBO **********/
	assign fwd_data	 = out;

	/********** ANZX䃆jbg **********/
	mem_ctrl mem_ctrl (
		/********** EX/MEMpCvCWX^ **********/
		.ex_en			(ex_en),			   // pCvCf[^̗L
		.ex_mem_op		(ex_mem_op),		   // Iy[V
		.ex_mem_wr_data (ex_mem_wr_data),	   // ݃f[^
		.ex_out			(ex_out),			   // 
		/********** ANZXC^tF[X **********/
		.rd_data		(rd_data),			   // ǂݏof[^
		.addr			(addr),				   // AhX
		.as_			(as_),				   // AhXL
		.rw				(rw),				   // ǂ݁^
		.wr_data		(wr_data),			   // ݃f[^
		/********** ANZX **********/
		.out			(out),				   // ANZX
		.miss_align		(miss_align)		   // ~XAC
	);

	/********** oXC^tF[X **********/
	bus_if bus_if (
		/********** NbN & Zbg **********/
		.clk		 (clk),					   // NbN
		.reset		 (reset),				   // 񓯊Zbg
		/********** pCvCM **********/
		.stall		 (stall),				   // Xg[
		.flush		 (flush),				   // tbVM
		.busy		 (busy),				   // rW[M
		/********** CPUC^tF[X **********/
		.addr		 (addr),				   // AhX
		.as_		 (as_),					   // AhXL
		.rw			 (rw),					   // ǂ݁^
		.wr_data	 (wr_data),				   // ݃f[^
		.rd_data	 (rd_data),				   // ǂݏof[^
		/********** XNb`pbhC^tF[X **********/
		.spm_rd_data (spm_rd_data),			   // ǂݏof[^
		.spm_addr	 (spm_addr),			   // AhX
		.spm_as_	 (spm_as_),				   // AhXXg[u
		.spm_rw		 (spm_rw),				   // ǂ݁^
		.spm_wr_data (spm_wr_data),			   // ݃f[^
		/********** oXC^tF[X **********/
		.bus_rd_data (bus_rd_data),			   // ǂݏof[^
		.bus_rdy_	 (bus_rdy_),			   // fB
		.bus_grnt_	 (bus_grnt_),			   // oXOg
		.bus_req_	 (bus_req_),			   // oXNGXg
		.bus_addr	 (bus_addr),			   // AhX
		.bus_as_	 (bus_as_),				   // AhXXg[u
		.bus_rw		 (bus_rw),				   // ǂ݁^
		.bus_wr_data (bus_wr_data)			   // ݃f[^
	);

	/********** MEMXe[WpCvCWX^ **********/
	mem_reg mem_reg (
		/********** NbN & Zbg **********/
		.clk		  (clk),				   // NbN
		.reset		  (reset),				   // 񓯊Zbg
		/********** ANZX **********/
		.out		  (out),				   // 
		.miss_align	  (miss_align),			   // ~XAC
		/********** pCvCM **********/
		.stall		  (stall),				   // Xg[
		.flush		  (flush),				   // tbV
		/********** EX/MEMpCvCWX^ **********/
		.ex_pc		  (ex_pc),				   // vOJE^
		.ex_en		  (ex_en),				   // pCvCf[^̗L
		.ex_br_flag	  (ex_br_flag),			   // tO
		.ex_ctrl_op	  (ex_ctrl_op),			   // 䃌WX^Iy[V
		.ex_dst_addr  (ex_dst_addr),		   // ėpWX^݃AhX
		.ex_gpr_we_	  (ex_gpr_we_),			   // ėpWX^ݗL
		.ex_exp_code  (ex_exp_code),		   // OR[h
		/********** MEM/WBpCvCWX^ **********/
		.mem_pc		  (mem_pc),				   // vOJE^
		.mem_en		  (mem_en),				   // pCvCf[^̗L
		.mem_br_flag  (mem_br_flag),		   // tO
		.mem_ctrl_op  (mem_ctrl_op),		   // 䃌WX^Iy[V
		.mem_dst_addr (mem_dst_addr),		   // ėpWX^݃AhX
		.mem_gpr_we_  (mem_gpr_we_),		   // ėpWX^ݗL
		.mem_exp_code (mem_exp_code),		   // OR[h
		.mem_out	  (mem_out)				   // 
	);

endmodule
