/*
 -- ============================================================================
 -- FILE NAME	: spm.v
 -- DESCRIPTION : XNb`pbh
 -- ----------------------------------------------------------------------------
 -- Revision  Date		  Coding_by	 Comment
 -- 1.0.0	  2011/06/27  suito		 VK쐬
 -- ============================================================================
*/

/********** ʃwb_t@C **********/
`include "nettype.h"
`include "global_config.h"
`include "stddef.h"

/********** ʃwb_t@C **********/
`include "spm.h"

/********** W[ **********/
module spm (
	/********** NbN **********/
	input  wire				   clk,				// NbN
	/********** |[gA : IFXe[W **********/
	input  wire [`SpmAddrBus]  if_spm_addr,		// AhX
	input  wire				   if_spm_as_,		// AhXXg[u
	input  wire				   if_spm_rw,		// ǂ݁^
	input  wire [`WordDataBus] if_spm_wr_data,	// ݃f[^
	output wire [`WordDataBus] if_spm_rd_data,	// ǂݏof[^
	/********** |[gB : MEMXe[W **********/
	input  wire [`SpmAddrBus]  mem_spm_addr,	// AhX
	input  wire				   mem_spm_as_,		// AhXXg[u
	input  wire				   mem_spm_rw,		// ǂ݁^
	input  wire [`WordDataBus] mem_spm_wr_data, // ݃f[^
	output wire [`WordDataBus] mem_spm_rd_data	// ǂݏof[^
);

	/********** ݗLM **********/
	reg						   wea;			// |[g A
	reg						   web;			// |[g B

	/********** ݗLM̐ **********/
	always @(*) begin
		/* |[g A */
		if ((if_spm_as_ == `ENABLE_) && (if_spm_rw == `WRITE)) begin   
			wea = `MEM_ENABLE;	// ݗL
		end else begin
			wea = `MEM_DISABLE; // ݖ
		end
		/* |[g B */
		if ((mem_spm_as_ == `ENABLE_) && (mem_spm_rw == `WRITE)) begin
			web = `MEM_ENABLE;	// ݗL
		end else begin
			web = `MEM_DISABLE; // ݖ
		end
	end

	/********** Xilinx FPGA Block RAM : fA|[gRAM **********/
	x_s3e_dpram x_s3e_dpram (
		/********** |[g A : IFXe[W **********/
		.clka  (clk),			  // NbN
		.addra (if_spm_addr),	  // AhX
		.dina  (if_spm_wr_data),  // ݃f[^iڑj
		.wea   (wea),			  // ݗLilQ[gj
		.douta (if_spm_rd_data),  // ǂݏof[^
		/********** |[g B : MEMXe[W **********/
		.clkb  (clk),			  // NbN
		.addrb (mem_spm_addr),	  // AhX
		.dinb  (mem_spm_wr_data), // ݃f[^
		.web   (web),			  // ݗL
		.doutb (mem_spm_rd_data)  // ǂݏof[^
	);
  
endmodule
