/*
 -- ============================================================================
 -- FILE NAME	: rom.v
 -- DESCRIPTION : Read Only Memory
 -- ----------------------------------------------------------------------------
 -- Revision  Date		  Coding_by	 Comment
 -- 1.0.0	  2011/06/27  suito		 VK쐬
 -- ============================================================================
*/

/********** ʃwb_t@C **********/
`include "nettype.h"
`include "stddef.h"
`include "global_config.h"

/********** ʃwb_t@C **********/
`include "rom.h"

/********** W[ **********/
module rom (
	/********** NbN & Zbg **********/
	input  wire				   clk,		// NbN
	input  wire				   reset,	// 񓯊Zbg
	/********** oXC^tF[X **********/
	input  wire				   cs_,		// `bvZNg
	input  wire				   as_,		// AhXXg[u
	input  wire [`RomAddrBus]  addr,	// AhX
	output wire [`WordDataBus] rd_data, // ǂݏof[^
	output reg				   rdy_		// fB
);

	/********** Xilinx FPGA Block RAM : VO|[gROM **********/
	x_s3e_sprom x_s3e_sprom (
		.clka  (clk),					// NbN
		.addra (addr),					// AhX
		.douta (rd_data)				// ǂݏof[^
	);

	/********** fB̐ **********/
	always @(posedge clk or `RESET_EDGE reset) begin
		if (reset == `RESET_ENABLE) begin
			/* 񓯊Zbg */
			rdy_ <= #1 `DISABLE_;
		end else begin
			/* fB̐ */
			if ((cs_ == `ENABLE_) && (as_ == `ENABLE_)) begin
				rdy_ <= #1 `ENABLE_;
			end else begin
				rdy_ <= #1 `DISABLE_;
			end
		end
	end

endmodule
