/*
 -- ============================================================================
 -- FILE NAME	: uart.v
 -- DESCRIPTION : Universal Asynchronous Receiver and Transmitter
 -- ----------------------------------------------------------------------------
 -- Revision  Date		  Coding_by	 Comment
 -- 1.0.0	  2011/06/27  suito		 VK쐬
 -- ============================================================================
*/

/********** ʃwb_t@C **********/
`include "nettype.h"
`include "stddef.h"
`include "global_config.h"

/********** ʃwb_t@C **********/
`include "uart.h"

/********** W[ **********/
module uart (
	/********** NbN & Zbg **********/
	input  wire				   clk,		 // NbN
	input  wire				   reset,	 // 񓯊Zbg
	/********** oXC^tF[X **********/
	input  wire				   cs_,		 // `bvZNg
	input  wire				   as_,		 // AhXXg[u
	input  wire				   rw,		 // Read / Write
	input  wire [`UartAddrBus] addr,	 // AhX
	input  wire [`WordDataBus] wr_data,	 // ݃f[^
	output wire [`WordDataBus] rd_data,	 // ǂݏof[^
	output wire				   rdy_,	 // fB
	/********** 荞 **********/
	output wire				   irq_rx,	 // M荞
	output wire				   irq_tx,	 // M荞
	/********** UARTMM	**********/
	input  wire				   rx,		 // UARTMM
	output wire				   tx		 // UARTMM
);

	/********** M **********/
	// M
	wire					   rx_busy;	 // MtO
	wire					   rx_end;	 // MM
	wire [`ByteDataBus]		   rx_data;	 // Mf[^
	// M
	wire					   tx_busy;	 // MtO
	wire					   tx_end;	 // MM
	wire					   tx_start; // MJnM
	wire [`ByteDataBus]		   tx_data;	 // Mf[^

	/********** UART䃂W[ **********/
	uart_ctrl uart_ctrl (
		/********** NbN & Zbg **********/
		.clk	  (clk),	   // NbN
		.reset	  (reset),	   // 񓯊Zbg
		/********** Host Interface **********/
		.cs_	  (cs_),	   // `bvZNg
		.as_	  (as_),	   // AhXXg[u
		.rw		  (rw),		   // Read / Write
		.addr	  (addr),	   // AhX
		.wr_data  (wr_data),   // ݃f[^
		.rd_data  (rd_data),   // ǂݏof[^
		.rdy_	  (rdy_),	   // fB
		/********** Interrupt  **********/
		.irq_rx	  (irq_rx),	   // M荞
		.irq_tx	  (irq_tx),	   // M荞
		/********** M **********/
		// M
		.rx_busy  (rx_busy),   // MtO
		.rx_end	  (rx_end),	   // MM
		.rx_data  (rx_data),   // Mf[^
		// M
		.tx_busy  (tx_busy),   // MtO
		.tx_end	  (tx_end),	   // MM
		.tx_start (tx_start),  // MJnM
		.tx_data  (tx_data)	   // Mf[^
	);

	/********** UARTMW[ **********/
	uart_tx uart_tx (
		/********** NbN & Zbg **********/
		.clk	  (clk),	   // NbN
		.reset	  (reset),	   // 񓯊Zbg
		/********** M **********/
		.tx_start (tx_start),  // MJnM
		.tx_data  (tx_data),   // Mf[^
		.tx_busy  (tx_busy),   // MtO
		.tx_end	  (tx_end),	   // MM
		/********** Transmit Signal **********/
		.tx		  (tx)		   // UARTMM
	);

	/********** UARTMW[ **********/
	uart_rx uart_rx (
		/********** NbN & Zbg **********/
		.clk	  (clk),	   // NbN
		.reset	  (reset),	   // 񓯊Zbg
		/********** M **********/
		.rx_busy  (rx_busy),   // MtO
		.rx_end	  (rx_end),	   // MM
		.rx_data  (rx_data),   // Mf[^
		/********** Receive Signal **********/
		.rx		  (rx)		   // UARTMM
	);

endmodule
