/*
 -- ============================================================================
 -- FILE NAME	: uart_ctrl.v
 -- DESCRIPTION : UART䃂W[
 -- ----------------------------------------------------------------------------
 -- Revision  Date		  Coding_by	 Comment
 -- 1.0.0	  2011/06/27  suito		 VK쐬
 -- ============================================================================
*/

/********** ʃwb_t@C **********/
`include "nettype.h"
`include "stddef.h"
`include "global_config.h"

/********** ʃwb_t@C **********/
`include "uart.h"

/********** W[ **********/
module uart_ctrl (
	/********** NbN & Zbg **********/
	input  wire				   clk,		 // NbN
	input  wire				   reset,	 // 񓯊Zbg
	/********** oXC^tF[X **********/
	input  wire				   cs_,		 // `bvZNg
	input  wire				   as_,		 // AhXXg[u
	input  wire				   rw,		 // Read / Write
	input  wire [`UartAddrBus] addr,	 // AhX
	input  wire [`WordDataBus] wr_data,	 // ݃f[^
	output reg	[`WordDataBus] rd_data,	 // ǂݏof[^
	output reg				   rdy_,	 // fB
	/********** 荞 **********/
	output reg				   irq_rx,	 // M荞݁i䃌WX^ 0j
	output reg				   irq_tx,	 // M荞݁i䃌WX^ 0j
	/********** M **********/
	// M
	input  wire				   rx_busy,	 // MtOi䃌WX^ 0j
	input  wire				   rx_end,	 // MM
	input  wire [`ByteDataBus] rx_data,	 // Mf[^
	// M
	input  wire				   tx_busy,	 // MtOi䃌WX^ 0j
	input  wire				   tx_end,	 // MM
	output reg				   tx_start, // MJnM
	output reg	[`ByteDataBus] tx_data	 // Mf[^
);

	/********** 䃌Wc^ **********/
	// 䃌WX^ 1 : Mf[^
	reg [`ByteDataBus]		   rx_buf;	 // Mobt@

	/********** UART_ **********/
	always @(posedge clk or `RESET_EDGE reset) begin
		if (reset == `RESET_ENABLE) begin
			/* 񓯊Zbg */
			rd_data	 <= #1 `WORD_DATA_W'h0;
			rdy_	 <= #1 `DISABLE_;
			irq_rx	 <= #1 `DISABLE;
			irq_tx	 <= #1 `DISABLE;
			rx_buf	 <= #1 `BYTE_DATA_W'h0;
			tx_start <= #1 `DISABLE;
			tx_data	 <= #1 `BYTE_DATA_W'h0;
	   end else begin
			/* fB̐ */
			if ((cs_ == `ENABLE_) && (as_ == `ENABLE_)) begin
				rdy_	 <= #1 `ENABLE_;
			end else begin
				rdy_	 <= #1 `DISABLE_;
			end
			/* ǂݏoANZX */
			if ((cs_ == `ENABLE_) && (as_ == `ENABLE_) && (rw == `READ)) begin
				case (addr)
					`UART_ADDR_STATUS	 : begin // 䃌WX^ 0
						rd_data	 <= #1 {{`WORD_DATA_W-4{1'b0}}, 
										tx_busy, rx_busy, irq_tx, irq_rx};
					end
					`UART_ADDR_DATA		 : begin // 䃌WX^ 1
						rd_data	 <= #1 {{`BYTE_DATA_W*2{1'b0}}, rx_buf};
					end
				endcase
			end else begin
				rd_data	 <= #1 `WORD_DATA_W'h0;
			end
			/* ݃ANZX */
			// 䃌WX^ 0 : M荞
			if (tx_end == `ENABLE) begin
				irq_tx<= #1 `ENABLE;
			end else if ((cs_ == `ENABLE_) && (as_ == `ENABLE_) && 
						 (rw == `WRITE) && (addr == `UART_ADDR_STATUS)) begin
				irq_tx<= #1 wr_data[`UartCtrlIrqTx];
			end
			// 䃌WX^ 0 : M荞
			if (rx_end == `ENABLE) begin
				irq_rx<= #1 `ENABLE;
			end else if ((cs_ == `ENABLE_) && (as_ == `ENABLE_) && 
						 (rw == `WRITE) && (addr == `UART_ADDR_STATUS)) begin
				irq_rx<= #1 wr_data[`UartCtrlIrqRx];
			end
			// 䃌WX^ 1
			if ((cs_ == `ENABLE_) && (as_ == `ENABLE_) && 
				(rw == `WRITE) && (addr == `UART_ADDR_DATA)) begin // MJn
				tx_start <= #1 `ENABLE;
				tx_data	 <= #1 wr_data[`BYTE_MSB:`LSB];
			end else begin
				tx_start <= #1 `DISABLE;
				tx_data	 <= #1 `BYTE_DATA_W'h0;
			end
			/* Mf[^̎荞 */
			if (rx_end == `ENABLE) begin
				rx_buf	 <= #1 rx_data;
			end
		end
	end

endmodule
