/*
 -- ============================================================================
 -- FILE NAME	: uart_rx.v
 -- DESCRIPTION : UARTMW[
 -- ----------------------------------------------------------------------------
 -- Revision  Date		  Coding_by	 Comment
 -- 1.0.0	  2011/06/27  suito		 VK쐬
 -- ============================================================================
*/

/********** ʃwb_t@C **********/
`include "nettype.h"
`include "stddef.h"
`include "global_config.h"

/********** ʃwb_t@C **********/
`include "uart.h"

/********** W[ **********/
module uart_rx (
	/********** NbN & Zbg **********/
	input  wire				   clk,		// NbN
	input  wire				   reset,	// 񓯊Zbg
	/********** M **********/
	output wire				   rx_busy, // MtO
	output reg				   rx_end,	// MM
	output reg	[`ByteDataBus] rx_data, // Mf[^
	/********** UARTMM **********/
	input  wire				   rx		// UARTMM
);

	/********** WX^ **********/
	reg [`UartStateBus]		   state;	 // Xe[g
	reg [`UartDivCntBus]	   div_cnt;	 // JE^
	reg [`UartBitCntBus]	   bit_cnt;	 // rbgJE^

	/********** MtO̐ **********/
	assign rx_busy = (state != `UART_STATE_IDLE) ? `ENABLE : `DISABLE;

	/********** M_ **********/
	always @(posedge clk or `RESET_EDGE reset) begin
		if (reset == `RESET_ENABLE) begin
			/* 񓯊Zbg */
			rx_end	<= #1 `DISABLE;
			rx_data <= #1 `BYTE_DATA_W'h0;
			state	<= #1 `UART_STATE_IDLE;
			div_cnt <= #1 `UART_DIV_RATE / 2;
			bit_cnt <= #1 `UART_BIT_CNT_W'h0;
		end else begin
			/* MXe[g */
			case (state)
				`UART_STATE_IDLE : begin // ACh
					if (rx == `UART_START_BIT) begin // MJn
						state	<= #1 `UART_STATE_RX;
					end
					rx_end	<= #1 `DISABLE;
				end
				`UART_STATE_RX	 : begin // M
					/* NbNɂ{[[g */
					if (div_cnt == {`UART_DIV_CNT_W{1'b0}}) begin // 
						/* f[^̎M */
						case (bit_cnt)
							`UART_BIT_CNT_STOP	: begin // Xgbvrbg̎M
								state	<= #1 `UART_STATE_IDLE;
								bit_cnt <= #1 `UART_BIT_CNT_START;
								div_cnt <= #1 `UART_DIV_RATE / 2;
								/* t[~OG[̃`FbN */
								if (rx == `UART_STOP_BIT) begin
									rx_end	<= #1 `ENABLE;
								end
							end
							default				: begin // f[^̎M
								rx_data <= #1 {rx, rx_data[`BYTE_MSB:`LSB+1]};
								bit_cnt <= #1 bit_cnt + 1'b1;
								div_cnt <= #1 `UART_DIV_RATE;
							end
						endcase
					end else begin // JEg_E
						div_cnt <= #1 div_cnt - 1'b1;
					end
				end
			endcase
		end
	end

endmodule
