/*
 -- ============================================================================
 -- FILE NAME	: uart_tx.v
 -- DESCRIPTION : UARTMW[
 -- ----------------------------------------------------------------------------
 -- Revision  Date		  Coding_by	 Comment
 -- 1.0.0	  2011/06/27  suito		 VK쐬
 -- ============================================================================
*/

/********** ʃwb_t@C **********/
`include "nettype.h"
`include "stddef.h"
`include "global_config.h"

/********** ʃwb_t@C **********/
`include "uart.h"

/********** W[ **********/
module uart_tx (
	/********** NbN & Zbg **********/
	input  wire				   clk,		 // NbN
	input  wire				   reset,	 // 񓯊Zbg
	/********** M **********/
	input  wire				   tx_start, // MJnM
	input  wire [`ByteDataBus] tx_data,	 // Mf[^
	output wire				   tx_busy,	 // MtO
	output reg				   tx_end,	 // MM
	/********** UARTMM **********/
	output reg				   tx		 // UARTMM
);

	/********** M **********/
	reg [`UartStateBus]		   state;	 // Xe[g
	reg [`UartDivCntBus]	   div_cnt;	 // JE^
	reg [`UartBitCntBus]	   bit_cnt;	 // rbgJE^
	reg [`ByteDataBus]		   sh_reg;	 // MpVtgWX^

	/********** MtO̐ **********/
	assign tx_busy = (state == `UART_STATE_TX) ? `ENABLE : `DISABLE;

	/********** M_ **********/
	always @(posedge clk or `RESET_EDGE reset) begin
		if (reset == `RESET_ENABLE) begin
			/* 񓯊Zbg */
			state	<= #1 `UART_STATE_IDLE;
			div_cnt <= #1 `UART_DIV_RATE;
			bit_cnt <= #1 `UART_BIT_CNT_START;
			sh_reg	<= #1 `BYTE_DATA_W'h0;
			tx_end	<= #1 `DISABLE;
			tx		<= #1 `UART_STOP_BIT;
		end else begin
			/* MXe[g */
			case (state)
				`UART_STATE_IDLE : begin // ACh
					if (tx_start == `ENABLE) begin // MJn
						state	<= #1 `UART_STATE_TX;
						sh_reg	<= #1 tx_data;
						tx		<= #1 `UART_START_BIT;
					end
					tx_end	<= #1 `DISABLE;
				end
				`UART_STATE_TX	 : begin // M
					/* NbNɂ{[[g */
					if (div_cnt == {`UART_DIV_CNT_W{1'b0}}) begin // 
						/* f[^̑M */
						case (bit_cnt)
							`UART_BIT_CNT_MSB  : begin // Xgbvrbg̑M
								bit_cnt <= #1 `UART_BIT_CNT_STOP;
								tx		<= #1 `UART_STOP_BIT;
							end
							`UART_BIT_CNT_STOP : begin // M
								state	<= #1 `UART_STATE_IDLE;
								bit_cnt <= #1 `UART_BIT_CNT_START;
								tx_end	<= #1 `ENABLE;
							end
							default			   : begin // f[^̑M
								bit_cnt <= #1 bit_cnt + 1'b1;
								sh_reg	<= #1 sh_reg >> 1'b1;
								tx		<= #1 sh_reg[`LSB];
							end
						endcase
						div_cnt <= #1 `UART_DIV_RATE;
					end else begin // JEg_E
						div_cnt <= #1 div_cnt - 1'b1 ;
					end
				end
			endcase
		end
	end

endmodule
