/*
 -- ============================================================================
 -- FILE NAME	: x_s3e_dpram.v
 -- DESCRIPTION : Xilinx Spartan-3E Dual Port RAM ^f
 -- ----------------------------------------------------------------------------
 -- Revision  Date		  Coding_by	 Comment
 -- 1.0.0	  2011/06/27  suito		 VK쐬
 -- ============================================================================
*/

/********** ʃwb_t@C **********/
`include "nettype.h"
`include "stddef.h"
`include "global_config.h"

/********** ʃwb_t@C **********/
`include "spm.h"

/********** W[ **********/
module x_s3e_dpram (
	/********** |[g A **********/
	input  wire				   clka,  // NbN
	input  wire [`SpmAddrBus]  addra, // AhX
	input  wire [`WordDataBus] dina,  // ݃f[^
	input  wire				   wea,	  // ݗL
	output reg	[`WordDataBus] douta, // ǂݏof[^
	/********** |[g B **********/
	input  wire				   clkb,  // NbN
	input  wire [`SpmAddrBus]  addrb, // AhX
	input  wire [`WordDataBus] dinb,  // ݃f[^
	input  wire				   web,	  // ݗL
	output reg	[`WordDataBus] doutb  // ǂݏof[^
);

	/**********  **********/
	reg [`WordDataBus] mem [0:`SPM_DEPTH-1];

	/********** ANZXi|[g Aj **********/
	always @(posedge clka) begin
		// ǂݏoANZX
		if ((web == `ENABLE) && (addra == addrb)) begin
			douta	  <= #1 dinb;
		end else begin
			douta	  <= #1 mem[addra];
		end
		// ݃ANZX
		if (wea == `ENABLE) begin
			mem[addra]<= #1 dina;
		end
	end

	/********** ANZXi|[g Bj **********/
	always @(posedge clkb) begin
		// ǂݏoANZX
		if ((wea == `ENABLE) && (addrb == addra)) begin
			doutb	  <= #1 dina;
		end else begin
			doutb	  <= #1 mem[addrb];
		end
		// ݃ANZX
		if (web == `ENABLE) begin
			mem[addrb]<= #1 dinb;
		end
	end

endmodule
