/* 
 -- ============================================================================
 -- FILE NAME	: chip.v
 -- DESCRIPTION : `bv
 -- ----------------------------------------------------------------------------
 -- Revision  Date		  Coding_by	 Comment
 -- 1.0.0	  2011/06/27  suito		 VK쐬
 -- ============================================================================
*/

/********** ʃwb_t@C **********/
`include "nettype.h"
`include "stddef.h"
`include "global_config.h"

/********** ʃwb_t@C **********/
`include "cpu.h"
`include "bus.h"
`include "rom.h"
`include "timer.h"
`include "uart.h"
`include "gpio.h"

/********** W[ **********/
module chip (
	/********** NbN & Zbg **********/
	input  wire						 clk,		  // NbN
	input  wire						 clk_,		  // ]NbN
	input  wire						 reset		  // Zbg
	/********** UART  **********/
`ifdef IMPLEMENT_UART // UART
	, input	 wire					 uart_rx	  // UARTMM
	, output wire					 uart_tx	  // UARTMM
`endif
	/********** ėpo̓|[g **********/
`ifdef IMPLEMENT_GPIO // GPIO
`ifdef GPIO_IN_CH	 // ̓|[g̎
	, input wire [`GPIO_IN_CH-1:0]	 gpio_in	  // ̓|[g
`endif
`ifdef GPIO_OUT_CH	 // o̓|[g̎
	, output wire [`GPIO_OUT_CH-1:0] gpio_out	  // o̓|[g
`endif
`ifdef GPIO_IO_CH	 // o̓|[g̎
	, inout wire [`GPIO_IO_CH-1:0]	 gpio_io	  // o̓|[g
`endif
`endif
);

	/********** oX}X^M **********/
	// S}X^ʐM~
	wire [`WordDataBus] m_rd_data;				  // ǂݏof[^
	wire				m_rdy_;					  // fB
	// oX}X^0
	wire				m0_req_;				  // oXNGXg
	wire [`WordAddrBus] m0_addr;				  // AhX
	wire				m0_as_;					  // AhXXg[u
	wire				m0_rw;					  // ǂ݁^
	wire [`WordDataBus] m0_wr_data;				  // ݃f[^
	wire				m0_grnt_;				  // oXOg
	// oX}X^1
	wire				m1_req_;				  // oXNGXg
	wire [`WordAddrBus] m1_addr;				  // AhX
	wire				m1_as_;					  // AhXXg[u
	wire				m1_rw;					  // ǂ݁^
	wire [`WordDataBus] m1_wr_data;				  // ݃f[^
	wire				m1_grnt_;				  // oXOg
	// oX}X^2
	wire				m2_req_;				  // oXNGXg
	wire [`WordAddrBus] m2_addr;				  // AhX
	wire				m2_as_;					  // AhXXg[u
	wire				m2_rw;					  // ǂ݁^
	wire [`WordDataBus] m2_wr_data;				  // ݃f[^
	wire				m2_grnt_;				  // oXOg
	// oX}X^3
	wire				m3_req_;				  // oXNGXg
	wire [`WordAddrBus] m3_addr;				  // AhX
	wire				m3_as_;					  // AhXXg[u
	wire				m3_rw;					  // ǂ݁^
	wire [`WordDataBus] m3_wr_data;				  // ݃f[^
	wire				m3_grnt_;				  // oXOg
	/********** oXX[uM **********/
	// SX[uʐM
	wire [`WordAddrBus] s_addr;					  // AhX
	wire				s_as_;					  // AhXXg[u
	wire				s_rw;					  // ǂ݁^
	wire [`WordDataBus] s_wr_data;				  // ݃f[^
	// oXX[u0
	wire [`WordDataBus] s0_rd_data;				  // ǂݏof[^
	wire				s0_rdy_;				  // fB
	wire				s0_cs_;					  // `bvZNg
	// oXX[u1
	wire [`WordDataBus] s1_rd_data;				  // ǂݏof[^
	wire				s1_rdy_;				  // fB
	wire				s1_cs_;					  // `bvZNg
	// oXX[u2
	wire [`WordDataBus] s2_rd_data;				  // ǂݏof[^
	wire				s2_rdy_;				  // fB
	wire				s2_cs_;					  // `bvZNg
	// oXX[u3
	wire [`WordDataBus] s3_rd_data;				  // ǂݏof[^
	wire				s3_rdy_;				  // fB
	wire				s3_cs_;					  // `bvZNg
	// oXX[u4
	wire [`WordDataBus] s4_rd_data;				  // ǂݏof[^
	wire				s4_rdy_;				  // fB
	wire				s4_cs_;					  // `bvZNg
	// oXX[u5
	wire [`WordDataBus] s5_rd_data;				  // ǂݏof[^
	wire				s5_rdy_;				  // fB
	wire				s5_cs_;					  // `bvZNg
	// oXX[u6
	wire [`WordDataBus] s6_rd_data;				  // ǂݏof[^
	wire				s6_rdy_;				  // fB
	wire				s6_cs_;					  // `bvZNg
	// oXX[u7
	wire [`WordDataBus] s7_rd_data;				  // ǂݏof[^
	wire				s7_rdy_;				  // fB
	wire				s7_cs_;					  // `bvZNg
	/********** 荞ݗvM **********/
	wire				   irq_timer;			  // ^C}IRQ
	wire				   irq_uart_rx;			  // UART IRQiMj
	wire				   irq_uart_tx;			  // UART IRQiMj
	wire [`CPU_IRQ_CH-1:0] cpu_irq;				  // CPU IRQ

	assign cpu_irq = {{`CPU_IRQ_CH-3{`LOW}}, 
					  irq_uart_rx, irq_uart_tx, irq_timer};

	/********** CPU **********/
	cpu cpu (
		/********** NbN & Zbg **********/
		.clk			 (clk),					  // NbN
		.clk_			 (clk_),				  // ]NbN
		.reset			 (reset),				  // 񓯊Zbg
		/********** oXC^tF[X **********/
		// IF Stage
		.if_bus_rd_data	 (m_rd_data),			  // ǂݏof[^
		.if_bus_rdy_	 (m_rdy_),				  // fB
		.if_bus_grnt_	 (m0_grnt_),			  // oXOg
		.if_bus_req_	 (m0_req_),				  // oXNGXg
		.if_bus_addr	 (m0_addr),				  // AhX
		.if_bus_as_		 (m0_as_),				  // AhXXg[u
		.if_bus_rw		 (m0_rw),				  // ǂ݁^
		.if_bus_wr_data	 (m0_wr_data),			  // ݃f[^
		// MEM Stage
		.mem_bus_rd_data (m_rd_data),			  // ǂݏof[^
		.mem_bus_rdy_	 (m_rdy_),				  // fB
		.mem_bus_grnt_	 (m1_grnt_),			  // oXOg
		.mem_bus_req_	 (m1_req_),				  // oXNGXg
		.mem_bus_addr	 (m1_addr),				  // AhX
		.mem_bus_as_	 (m1_as_),				  // AhXXg[u
		.mem_bus_rw		 (m1_rw),				  // ǂ݁^
		.mem_bus_wr_data (m1_wr_data),			  // ݃f[^
		/********** 荞 **********/
		.cpu_irq		 (cpu_irq)				  // 荞ݗv
	);

	/********** oX}X^ 2 :  **********/
	assign m2_addr	  = `WORD_ADDR_W'h0;
	assign m2_as_	  = `DISABLE_;
	assign m2_rw	  = `READ;
	assign m2_wr_data = `WORD_DATA_W'h0;
	assign m2_req_	  = `DISABLE_;

	/********** oX}X^ 3 :  **********/
	assign m3_addr	  = `WORD_ADDR_W'h0;
	assign m3_as_	  = `DISABLE_;
	assign m3_rw	  = `READ;
	assign m3_wr_data = `WORD_DATA_W'h0;
	assign m3_req_	  = `DISABLE_;
   
	/********** oXX[u 0 : ROM **********/
	rom rom (
		/********** Clock & Reset **********/
		.clk			 (clk),					  // NbN
		.reset			 (reset),				  // 񓯊Zbg
		/********** Bus Interface **********/
		.cs_			 (s0_cs_),				  // `bvZNg
		.as_			 (s_as_),				  // AhXXg[u
		.addr			 (s_addr[`RomAddrLoc]),	  // AhX
		.rd_data		 (s0_rd_data),			  // ǂݏof[^
		.rdy_			 (s0_rdy_)				  // fB
	);

	/********** oXX[u 1 : Scratch Pad Memory **********/
	assign s1_rd_data = `WORD_DATA_W'h0;
	assign s1_rdy_	  = `DISABLE_;

	/********** oXX[u 2 : ^C} **********/
`ifdef IMPLEMENT_TIMER // ^C}
	timer timer (
		/********** NbN & Zbg **********/
		.clk			 (clk),					  // NbN
		.reset			 (reset),				  // Zbg
		/********** oXC^tF[X **********/
		.cs_			 (s2_cs_),				  // `bvZNg
		.as_			 (s_as_),				  // AhXXg[u
		.addr			 (s_addr[`TimerAddrLoc]), // AhX
		.rw				 (s_rw),				  // Read / Write
		.wr_data		 (s_wr_data),			  // ݃f[^
		.rd_data		 (s2_rd_data),			  // ǂݏof[^
		.rdy_			 (s2_rdy_),				  // fB
		/********** 荞 **********/
		.irq			 (irq_timer)			  // 荞ݗv
	 );
`else				   // ^C}
	assign s2_rd_data = `WORD_DATA_W'h0;
	assign s2_rdy_	  = `DISABLE_;
	assign irq_timer  = `DISABLE;
`endif

	/********** oXX[u 3 : UART **********/
`ifdef IMPLEMENT_UART // UART
	uart uart (
		/********** NbN & Zbg **********/
		.clk			 (clk),					  // NbN
		.reset			 (reset),				  // 񓯊Zbg
		/********** oXC^tF[X **********/
		.cs_			 (s3_cs_),				  // `bvZNg
		.as_			 (s_as_),				  // AhXXg[u
		.rw				 (s_rw),				  // Read / Write
		.addr			 (s_addr[`UartAddrLoc]),  // AhX
		.wr_data		 (s_wr_data),			  // ݃f[^
		.rd_data		 (s3_rd_data),			  // ǂݏof[^
		.rdy_			 (s3_rdy_),				  // fB
		/********** 荞 **********/
		.irq_rx			 (irq_uart_rx),			  // M荞
		.irq_tx			 (irq_uart_tx),			  // M荞
		/********** UARTMM	**********/
		.rx				 (uart_rx),				  // UARTMM
		.tx				 (uart_tx)				  // UARTMM
	);
`else				  // UART
	assign s3_rd_data  = `WORD_DATA_W'h0;
	assign s3_rdy_	   = `DISABLE_;
	assign irq_uart_rx = `DISABLE;
	assign irq_uart_tx = `DISABLE;
`endif

	/********** oXX[u 4 : GPIO **********/
`ifdef IMPLEMENT_GPIO // GPIO
	gpio gpio (
		/********** NbN & Zbg **********/
		.clk			 (clk),					 // NbN
		.reset			 (reset),				 // Zbg
		/********** oXC^tF[X **********/
		.cs_			 (s4_cs_),				 // `bvZNg
		.as_			 (s_as_),				 // AhXXg[u
		.rw				 (s_rw),				 // Read / Write
		.addr			 (s_addr[`GpioAddrLoc]), // AhX
		.wr_data		 (s_wr_data),			 // ݃f[^
		.rd_data		 (s4_rd_data),			 // ǂݏof[^
		.rdy_			 (s4_rdy_)				 // fB
		/********** ėpo̓|[g **********/
`ifdef GPIO_IN_CH	 // ̓|[g̎
		, .gpio_in		 (gpio_in)				 // ̓|[g
`endif
`ifdef GPIO_OUT_CH	 // o̓|[g̎
		, .gpio_out		 (gpio_out)				 // o̓|[g
`endif
`ifdef GPIO_IO_CH	 // o̓|[g̎
		, .gpio_io		 (gpio_io)				 // o̓|[g
`endif
	);
`else				  // GPIO
	assign s4_rd_data = `WORD_DATA_W'h0;
	assign s4_rdy_	  = `DISABLE_;
`endif

	/********** oXX[u 5 :  **********/
	assign s5_rd_data = `WORD_DATA_W'h0;
	assign s5_rdy_	  = `DISABLE_;
  
	/********** oXX[u 6 :  **********/
	assign s6_rd_data = `WORD_DATA_W'h0;
	assign s6_rdy_	  = `DISABLE_;
  
	/********** oXX[u 7 :  **********/
	assign s7_rd_data = `WORD_DATA_W'h0;
	assign s7_rdy_	  = `DISABLE_;

	/********** oX **********/
	bus bus (
		/********** NbN & Zbg **********/
		.clk			 (clk),					 // NbN
		.reset			 (reset),				 // 񓯊Zbg
		/********** oX}X^M **********/
		// S}X^ʐM
		.m_rd_data		 (m_rd_data),			 // ǂݏof[^
		.m_rdy_			 (m_rdy_),				 // fB
		// oX}X^0
		.m0_req_		 (m0_req_),				 // oXNGXg
		.m0_addr		 (m0_addr),				 // AhX
		.m0_as_			 (m0_as_),				 // AhXXg[u
		.m0_rw			 (m0_rw),				 // ǂ݁^
		.m0_wr_data		 (m0_wr_data),			 // ݃f[^
		.m0_grnt_		 (m0_grnt_),			 // oXOg
		// oX}X^1
		.m1_req_		 (m1_req_),				 // oXNGXg
		.m1_addr		 (m1_addr),				 // AhX
		.m1_as_			 (m1_as_),				 // AhXXg[u
		.m1_rw			 (m1_rw),				 // ǂ݁^
		.m1_wr_data		 (m1_wr_data),			 // ݃f[^
		.m1_grnt_		 (m1_grnt_),			 // oXOg
		// oX}X^2
		.m2_req_		 (m2_req_),				 // oXNGXg
		.m2_addr		 (m2_addr),				 // AhX
		.m2_as_			 (m2_as_),				 // AhXXg[u
		.m2_rw			 (m2_rw),				 // ǂ݁^
		.m2_wr_data		 (m2_wr_data),			 // ݃f[^
		.m2_grnt_		 (m2_grnt_),			 // oXOg
		// oX}X^3
		.m3_req_		 (m3_req_),				 // oXNGXg
		.m3_addr		 (m3_addr),				 // AhX
		.m3_as_			 (m3_as_),				 // AhXXg[u
		.m3_rw			 (m3_rw),				 // ǂ݁^
		.m3_wr_data		 (m3_wr_data),			 // ݃f[^
		.m3_grnt_		 (m3_grnt_),			 // oXOg
		/********** oXX[uM **********/
		// SX[uʐM
		.s_addr			 (s_addr),				 // AhX
		.s_as_			 (s_as_),				 // AhXXg[u
		.s_rw			 (s_rw),				 // ǂ݁^
		.s_wr_data		 (s_wr_data),			 // ݃f[^
		// oXX[u0
		.s0_rd_data		 (s0_rd_data),			 // ǂݏof[^
		.s0_rdy_		 (s0_rdy_),				 // fB
		.s0_cs_			 (s0_cs_),				 // `bvZNg
		// oXX[u1
		.s1_rd_data		 (s1_rd_data),			 // ǂݏof[^
		.s1_rdy_		 (s1_rdy_),				 // fB
		.s1_cs_			 (s1_cs_),				 // `bvZNg
		// oXX[u2
		.s2_rd_data		 (s2_rd_data),			 // ǂݏof[^
		.s2_rdy_		 (s2_rdy_),				 // fB
		.s2_cs_			 (s2_cs_),				 // `bvZNg
		// oXX[u3
		.s3_rd_data		 (s3_rd_data),			 // ǂݏof[^
		.s3_rdy_		 (s3_rdy_),				 // fB
		.s3_cs_			 (s3_cs_),				 // `bvZNg
		// oXX[u4
		.s4_rd_data		 (s4_rd_data),			 // ǂݏof[^
		.s4_rdy_		 (s4_rdy_),				 // fB
		.s4_cs_			 (s4_cs_),				 // `bvZNg
		// oXX[u5
		.s5_rd_data		 (s5_rd_data),			 // ǂݏof[^
		.s5_rdy_		 (s5_rdy_),				 // fB
		.s5_cs_			 (s5_cs_),				 // `bvZNg
		// oXX[u6
		.s6_rd_data		 (s6_rd_data),			 // ǂݏof[^
		.s6_rdy_		 (s6_rdy_),				 // fB
		.s6_cs_			 (s6_cs_),				 // `bvZNg
		// oXX[u7
		.s7_rd_data		 (s7_rd_data),			 // ǂݏof[^
		.s7_rdy_		 (s7_rdy_),				 // fB
		.s7_cs_			 (s7_cs_)				 // `bvZNg
	);

endmodule
