/* 
 -- ============================================================================
 -- FILE NAME	: chip_top.v
 -- DESCRIPTION : gbvW[
 -- ----------------------------------------------------------------------------
 -- Revision  Date		  Coding_by	 Comment
 -- 1.0.0	  2011/06/27  suito		 VK쐬
 -- ============================================================================
*/

/********** ʃwb_t@C **********/
`include "nettype.h"
`include "stddef.h"
`include "global_config.h"

/********** ʃwb_t@C **********/
`include "gpio.h"

/********** W[ **********/
module chip_top (
	/********** NbN & Zbg **********/
	input wire				   clk_ref,		  // NbN
	input wire				   reset_sw		  // O[oZbg
	/********** UART **********/
`ifdef IMPLEMENT_UART // UART
	, input wire			   uart_rx		  // UARTMM
	, output wire			   uart_tx		  // UARTMM
`endif
	/********** ėpo̓|[g **********/
`ifdef IMPLEMENT_GPIO // GPIO
`ifdef GPIO_IN_CH	 // ̓|[g̎
	, input wire [`GPIO_IN_CH-1:0]	 gpio_in  // ̓|[g
`endif
`ifdef GPIO_OUT_CH	 // o̓|[g̎
	, output wire [`GPIO_OUT_CH-1:0] gpio_out // o̓|[g
`endif
`ifdef GPIO_IO_CH	 // o̓|[g̎
	, inout wire [`GPIO_IO_CH-1:0]	 gpio_io  // o̓|[g
`endif
`endif
);

	/********** NbN & Zbg **********/
	wire					   clk;			  // NbN
	wire					   clk_;		  // ]NbN
	wire					   chip_reset;	  // `bvZbg
   
	/********** NbNW[ **********/
	clk_gen clk_gen (
		/********** NbN & Zbg **********/
		.clk_ref	  (clk_ref),			  // NbN
		.reset_sw	  (reset_sw),			  // O[oZbg
		/********** NbN **********/
		.clk		  (clk),				  // NbN
		.clk_		  (clk_),				  // ]NbN
		/********** `bvZbg **********/
		.chip_reset	  (chip_reset)			  // `bvZbg
	);

	/********** `bv **********/
	chip chip (
		/********** NbN & Zbg **********/
		.clk	  (clk),					  // NbN
		.clk_	  (clk_),					  // ]NbN
		.reset	  (chip_reset)				  // Zbg
		/********** UART **********/
`ifdef IMPLEMENT_UART
		, .uart_rx	(uart_rx)				  // UARTMg`
		, .uart_tx	(uart_tx)				  // UARTMg`
`endif
		/********** ėpo̓|[g **********/
`ifdef IMPLEMENT_GPIO
`ifdef GPIO_IN_CH  // ̓|[g̎
		, .gpio_in (gpio_in)				  // ̓|[g
`endif
`ifdef GPIO_OUT_CH // o̓|[g̎
		, .gpio_out (gpio_out)				  // o̓|[g
`endif
`ifdef GPIO_IO_CH  // o̓|[g̎
		, .gpio_io	(gpio_io)				  // o̓|[g
`endif
`endif
	);

endmodule
