/* 
 -- ============================================================================
 -- FILE NAME	: clk_gen.v
 -- DESCRIPTION : NbNW[
 -- ----------------------------------------------------------------------------
 -- Revision  Date		  Coding_by	 Comment
 -- 1.0.0	  2011/06/27  suito		 VK쐬
 -- ============================================================================
*/

/********** ʃwb_t@C **********/
`include "nettype.h"
`include "stddef.h"
`include "global_config.h"

/********** W[ **********/
module clk_gen (
	/********** NbN & Zbg **********/
	input wire	clk_ref,   // NbN
	input wire	reset_sw,  // ZbgXCb`
	/********** NbN **********/
	output wire clk,	   // NbN
	output wire clk_,	   // ]NbN
	/********** `bvZbg **********/
	output wire chip_reset // `bvZbg
);

	/********** M **********/
	wire		locked;	   // bN
	wire		dcm_reset; // Zbg

	/********** Zbg̐ **********/
	// DCMZbg
	assign dcm_reset  = (reset_sw == `RESET_ENABLE) ? `ENABLE : `DISABLE;
	// `bvZbg
	assign chip_reset = ((reset_sw == `RESET_ENABLE) || (locked == `DISABLE)) ?
							`RESET_ENABLE : `RESET_DISABLE;

	/********** Xilinx DCM (Digitl Clock Manager) **********/
	x_s3e_dcm x_s3e_dcm (
		.CLKIN_IN		 (clk_ref),	  // NbN
		.RST_IN			 (dcm_reset), // DCMZbg
		.CLK0_OUT		 (clk),		  // NbN
		.CLK180_OUT		 (clk_),	  // ]NbN
		.LOCKED_OUT		 (locked)	  // bN
   );

endmodule
