/* 
 -- ============================================================================
 -- FILE NAME	: chip_top_test.v
 -- DESCRIPTION : eXgx`
 -- ----------------------------------------------------------------------------
 -- Revision  Date		  Coding_by	 Comment
 -- 1.0.0	  2012/04/02  suito		 VK쐬
 -- ============================================================================
*/

/********** ^CXP[ **********/
`timescale 1ns/1ps					 // ^CXP[

/********** ʃwb_t@C **********/
`include "nettype.h"
`include "stddef.h"
`include "global_config.h"

/********** ʃwb_t@C **********/
`include "bus.h"
`include "cpu.h"
`include "gpio.h"

/********** W[ **********/
module chip_top_test;
	/********** o͐M **********/
	// NbN & Zbg
	reg						clk_ref;	   // NbN
	reg						reset_sw;	   // O[oZbg
	// UART
`ifdef IMPLEMENT_UART // UART
	wire					uart_rx;	   // UARTMM
	wire					uart_tx;	   // UARTMM
`endif
	// ėpo̓|[g
`ifdef IMPLEMENT_GPIO // GPIO
`ifdef GPIO_IN_CH	 // ̓|[g̎
	wire [`GPIO_IN_CH-1:0]	gpio_in = {`GPIO_IN_CH{1'b0}}; // ̓|[g
`endif
`ifdef GPIO_OUT_CH	 // o̓|[g̎
	wire [`GPIO_OUT_CH-1:0] gpio_out;					   // o̓|[g
`endif
`ifdef GPIO_IO_CH	 // o̓|[g̎
	wire [`GPIO_IO_CH-1:0]	gpio_io = {`GPIO_IO_CH{1'bz}}; // o̓|[g
`endif
`endif
						 
	/********** UARTf **********/
`ifdef IMPLEMENT_UART // UART
	wire					 rx_busy;		  // MtO
	wire					 rx_end;		  // MM
	wire [`ByteDataBus]		 rx_data;		  // Mf[^
`endif

	/********** V~[VTCN **********/
	parameter				 STEP = 100.0000; // 10 M

	/********** NbN **********/
	always #( STEP / 2 ) begin
		clk_ref <= ~clk_ref;
	end

	/********** chip_top̃CX^X **********/  
	chip_top chip_top (
		/********** NbN & Zbg **********/
		.clk_ref	(clk_ref), // NbN
		.reset_sw	(reset_sw) // O[oZbg
		/********** UART **********/
`ifdef IMPLEMENT_UART // UART
		, .uart_rx	(uart_rx)  // UARTMM
		, .uart_tx	(uart_tx)  // UARTMM
`endif
	/********** ėpo̓|[g **********/
`ifdef IMPLEMENT_GPIO // GPIO
`ifdef GPIO_IN_CH			   // ̓|[g̎
		, .gpio_in	(gpio_in)  // ̓|[g
`endif
`ifdef GPIO_OUT_CH	 // o̓|[g̎
		, .gpio_out (gpio_out) // o̓|[g
`endif
`ifdef GPIO_IO_CH	 // o̓|[g̎
		, .gpio_io	(gpio_io)  // o̓|[g
`endif
`endif
);

	/********** GPIÕj^O **********/	
`ifdef IMPLEMENT_GPIO // GPIO
`ifdef GPIO_IN_CH	 // ̓|[g̎
	always @(gpio_in) begin	 // gpio_inωlvg
		$display($time, " gpio_in changed  : %b", gpio_in);
	end
`endif
`ifdef GPIO_OUT_CH	 // o̓|[g̎
	always @(gpio_out) begin // gpio_outωlvg
		$display($time, " gpio_out changed : %b", gpio_out);
	end
`endif
`ifdef GPIO_IO_CH	 // o̓|[g̎
	always @(gpio_io) begin // gpio_ioωlvg
		$display($time, " gpio_io changed  : %b", gpio_io);
	end
`endif
`endif

	/********** UARTf̃CX^X **********/	
`ifdef IMPLEMENT_UART // UART
	/********** MM **********/  
	assign uart_rx = `HIGH;		// ACh
//	  assign uart_rx = uart_tx; // [vobN

	/********** UARTf **********/	
	uart_rx uart_model (
		/********** NbN & Zbg **********/
		.clk	  (chip_top.clk),		 // NbN
		.reset	  (chip_top.chip_reset), // 񓯊Zbg
		/********** M **********/
		.rx_busy  (rx_busy),			 // MtO
		.rx_end	  (rx_end),				 // MM
		.rx_data  (rx_data),			 // Mf[^
		/********** Receive Signal **********/
		.rx		  (uart_tx)				 // UARTMM
	);

	/********** MM̃j^O **********/	
	always @(posedge chip_top.clk) begin
		if (rx_end == `ENABLE) begin // M當o
			$write("%c", rx_data);
		end
	end
`endif

	/********** eXgV[PX **********/  
	initial begin
		# 0 begin
			clk_ref	 <= `HIGH;
			reset_sw <= `RESET_ENABLE;
		end
		# ( STEP / 2 )
		# ( STEP / 4 ) begin		  // C[W̓ǂݍ
			$readmemh(`ROM_PRG, chip_top.chip.rom.x_s3e_sprom.mem);
			$readmemh(`SPM_PRG, chip_top.chip.cpu.spm.x_s3e_dpram.mem);
		end
		# ( STEP * 20 ) begin		  // Zbg̉
			reset_sw <= `RESET_DISABLE;
		end
		# ( STEP * `SIM_CYCLE ) begin // V~[V̎s
			$finish;
		end
	end

	/********** g`̏o **********/	
	initial begin
		$dumpfile("chip_top.vcd");
		$dumpvars(0, chip_top);
	end
  
endmodule	
